#/bin/bash

# Usage: call the script from anywhere, it should work!
# This is a build.sh helper script which builds releases in diconnected mode
# ie. when disconnected from a Revision Control System.

this_script_dir=$(cd $(dirname $0) && pwd)

project_root="$this_script_dir"

build_sh=$(find "$project_root/build" -name build.sh)
build_dir=$(dirname $build_sh)
config_dir=$(dirname $(find "$project_root/config" -name project.list))

# Create rootpath.cfg adapted to where the source will be compiled
cat << END > "$build_dir/rootpath.cfg"
w1=$project_root
n1=$project_root
END

# Workaround build.sh looking for server.cfg even when nosync option is passed
cp "$build_dir/server.cfg.sample" "$build_dir/server.cfg"

# Workaround build.sh that can't be run from outside of its directory
cd "$build_dir"

"$build_sh" "$config_dir" nosync nocleanstaging $* 2>&1 | tee "$project_root/build.log"

