#!/bin/sh
# the next line restarts using tclsh \
    exec tclsh "$0" "$@"

set scriptdir [file dirname [info script]]
set libDirectory [file join $scriptdir lib]
set auto_path [linsert $auto_path 0 $libDirectory]

package require buildsystem
namespace import buildsystem::*

#parse commandline options
buildsystem::parseConfigTestArgs $::argv
array set globaloptions [buildsystem::getGlobalOptions]

#read the server.cfg
array set globalbuildcfg [buildsystem::read_servers $globaloptions("buildconfigfile")]

#read componentlist
array set globalcomponentlst [buildsystem::read_components "$scriptdir/component.lst"]

# we directly read out a dependency file which acts more as a meta package
set cnames [buildsystem::read_componentdeps $globaloptions("projectdependenciesfile") componentdeps 0]


buildsystem::createRunTestScript
buildsystem::createCleanupTestScript
buildsystem::createInitializeEnvironmentTestScript
buildsystem::createInitializeTestScript
buildsystem::createTestSourcesScript
