package provide buildsystem 1.0

namespace eval buildsystem {
      variable globalbuildcfg
      variable globalrootpathlst

  namespace export get_perforce_rootpath read_rootpathcfg
}

# get perforce rootpath
proc buildsystem::get_perforce_rootpath {servername} {
    variable globalbuildcfg

        array set server $globalbuildcfg($servername)
        lassign [split $server(serveraddress) "/"] proto workspace

        log::log debug "Executing perforce command: p4 -p $proto -c $workspace client -o"
        return [string trim [exec "p4" "-p" "$proto" "-c" "$workspace" "client" "-o" "|" "sed" "-n" {s/^Root:[ \/t]*//p}]]
} 

proc buildsystem::read_rootpathcfg {filename} {
    variable globalrootpathlst

    log::log debug "Reading rootpath configuration"
    if [file exists $filename] { 
	log::log debug "Opening $filename"
	set infile [open $filename r]

	while { [gets $infile line] >= 0} {
	    # is line not empty
	    if [string length $line] {
		# line starting with # are treated as comment
		if [regexp {^#} $line] {
		    continue
		}
	    }

	    set parts [split $line "="]
	    lassign $parts server rootpath
	    set globalrootpathlst($server) $rootpath
	}
     close $infile
     } else {
	puts "Error: no $filename found"
	exit 1
     }
     return [array get globalrootpathlst]
}
