#!/usr/bin/perl
use strict;

our $cplst      = {};
my $cp_file     = "";

if ($ARGV[0] eq "") {
    $cp_file     ="component.lst";
} else {
    $cp_file   = $ARGV[0];
}

parseComponentLst($cp_file);
exit 0;

sub parseComponentLst {
    my  $fh;
    my  $file   = shift;
    our $cplst;
    my  $cp;
    my  $location;
    my  $server;

    open($fh, "cat $file |");
    while (!eof($fh)) {
        my $line = <$fh>;
        if ($line =~ /^(.*)=(.*):(.*)$/) {
            $cp         = $1;
            $server     = $2;
            $location   = $3;
            if (!defined($cplst->{$cp})) {
                $cplst->{$cp}->{"server"}   = $server;
                $cplst->{$cp}->{"location"} = $location;
            } else {
                print "Duplicate component definition found ${cp}=${server}:${location} conflicts with " .  
                $cplst->{$cp}->{"server"} . ":" . $cplst->{$cp}->{"location"} . "\n";
            }
        }
    }
    close $fh;
}

