#!/usr/bin/perl

if (($#ARGV) != 0 && ($#ARGV) != 1) {
	print "Recursively change the release number and reset the spin number in the defconfig of the projects.\n";
	print "Usage: ./chver.pl <version_string> [<spin_number>]\n";
	print "Example: ./chver.pl 3.50.1\n";
	print "Example: ./chver.pl 3.50.1 03\n";
	exit 0;
}

$what = "defconfig";
$ver   = shift;
$spin  = shift;

$spin_length = length($spin);
if (!$spin_length) {
	$spin = "00";
} elsif (1 == $spin_length) {
	$spin = "0".$spin;
}

print "Recursively setting version to '$ver', spin='$spin'\n";

@files = `find . -name $what`;

foreach $name (@files) {
	chomp $name;
	print "\nScanning $name\n";
	$touched = 0;

	#read in file
	open FILE, $name or die $!;
	@lines = <FILE>;
	close FILE;

	# check if we (need to) replace something
	@newfile = ();
	foreach $line (@lines) {
	    if ($line =~ m/CONFIG_VERSION_NAME_MAJOR=/) {
		$newline = "CONFIG_VERSION_NAME_MAJOR=\"$ver\"\n";
		print "$line -> $newline";
		$line = $newline;
		$touched = 1;
	    }
	    elsif ($line =~ m/CONFIG_BUILD_SPIN_NUMBER=/) {
		$newline = "CONFIG_BUILD_SPIN_NUMBER=\"$spin\"\n";
		print "$line -> $newline";
		$line = $newline;
		$touched = 1;
	    }
	    push(@newfile, $line);
	}

	# if we edit, p4 edit and rewrite
	if ($touched) {
	    print ">>>>Editing $name\n";
	    system "p4 edit $name";
	    open FILE, "+>", $name or die $!;
	    print FILE @newfile;
	    close FILE;
	}
}
