#!/bin/bash
##############################################################################
#
#   Tool for sorting the components within the project.list(s)
#   Needs to be run from within the build directory.
#   Takes the config path as an argument.
#   
#   Email <david.cluytens_ext@softathome.com>
##############################################################################

if [ -z $1 ]
then
    echo "tools/sort_project.sh <config_path>"
    exit 1
fi

config_path=$1
PCONFIG=tools/pconfig.pl
projs=`find $config_path -name project.list`

for proj in $projs
do
    $PCONFIG --print --file $proj > $proj.tmp
    p4 edit $proj
    mv $proj.tmp $proj
done

