#!/usr/bin/perl

# File::Find is just not good enough
# Do a manual traversal instead.

use strict;
use File::Spec;
use Cwd;

my $startdir = cwd();
print "Root: $startdir\n";

recursive_unpatch();

sub recursive_unpatch {
	my @content = `ls --group-directories-first -1`;
	@content = reverse @content;
	
	foreach my $thing (@content) {
		chomp $thing;
		# it's a file, patch it if possib;e
		if (-f $thing) {			
			# are we a patch file?
			if ($thing =~ /(.*)\.patch/) {
				my $basename = $1;
				# get our name, parent name, pos relative to root
				my $fname = $thing;
				my $parent   = File::Spec->updir();
				my $abs_path = Cwd::abs_path($fname);
				my $rel_path = File::Spec->abs2rel($abs_path, $startdir);
				my $me = $rel_path;	

#				if (-e $basename) {
#					die "Wont suicide $basename from $me\n";
#				}	
		
				# do we have a daddy?
				if (-e "$parent/$basename") {
					unpatchify($basename, $fname, "$parent/$basename");
#					print $me . " -> $basename\n";
				} else {
					die "Who's your daddy?? ($me)\n";
				}
			}
		} elsif (-d $thing) {
			my $mydir = cwd();
			chdir $thing;
			recursive_unpatch();
			chdir $mydir;
		}
	}	
};

sub unpatchify {
	my $zero = shift;
	my $one  = shift;
	my $two  = shift;

	my $thisdir = cwd();

        system("p4 edit $thisdir/$zero &> /dev/null");
	system("cp -f $two $zero");	
	system("patch -g0 $thisdir/$zero $one");	
	system("p4 revert -a $thisdir/$zero &> /dev/null");
	system("rm $one");
};
