#!/usr/bin/perl

if (($#ARGV + 1) != 3) {
	print "Search & replace on all files matching the first argument.\n";
	print "Usage: ./upgrade.pl <file_name> <fromstring> <tostring>\n";
	exit 0;
}

$what = shift;
$from = shift;
$to   = shift;

print "Replacing '$from' with '$to'\n";

@files = `find . -name $what`;

foreach $name (@files) {
	chomp $name;
	print "Scanning $name\n";
	$touched = 0;

	#read in file
	open FILE, $name or die $!;
	@lines = <FILE>;
	close FILE;

	# check if we (need to) replace something
	@newfile = ();
	foreach $line (@lines) {
		$oldline = $line;
		$line =~ s#$from#$to#g;
		if ($line ne $oldline) {
			print "$name : $from -> $to\n";
			$touched = 1;
		}
		push(@newfile, $line);
	}

	# if we edit, p4 edit and rewrite
	if ($touched) {
		#print ">>>>Editing $name\n";
		system "p4 edit $name";
		open FILE, "+>", $name or die $!;
		print FILE @newfile;
		close FILE;
	}
}
