#!/usr/bin/perl

sub get_current_version
{
	my $version=`cat $ENV{STAGINGDIR}/components.config | grep CONFIG_VERSION_NAME_MAJOR`;
	$version =~ s/.*\"(.*)\"/$1/;
	chomp($version);
	return $version;
}

sub check_return_value
{
	if ($?) {
		die "Error: $_[0]";
	}
}

my $original_version=get_current_version();
my $clone_version=`get_clone_version.pl`;
check_return_value("Unable to retrieve the clone version number");
`sed -i "s/CONFIG_VERSION_NAME_MAJOR=.*/CONFIG_VERSION_NAME_MAJOR=\\"$clone_version\\"\\nCLONE_BUILD=1/" $ENV{ROOT_FS_DIR}/web/version.txt`;
check_return_value("Unable to update version.txt");

my $file_location=`find $ENV{ROOT_FS_DIR} -iname issue.local`;
chomp($file_location);
if ( -e "$file_location" )
{
	`sed -i "s/$original_version/$clone_version/" $file_location`;
	`echo CLONE_BUILD for $original_version >> $file_location`;
}
else
{
	print "Unable to locate issue.local";
}






