ifdef STAGINGDIR
include $(STAGINGDIR)/components.config
endif

FFMPEG_NAME="ffmpeg-svn15004"
FFMPEG_PREFIX=$(STAGINGDIR)
FFMPEG_CONFIG_FILE=ffmpeg_config.in.hgw
FFMPEG_CONFIG_EXTRA=
FFMPEG_CONFIG_DEBUG=n
EXTRA_CFLAGS=-fPIC
EXTRA_LDFLAGS=

ifeq ($(CONFIG_SAH_LIB_FFMPEG_OPTIMIZED_BY_SIZE),y)
FFMPEG_CONFIG_EXTRA+=--enable-small
endif   

export FFMPEG_NAME
export FFMPEG_PREFIX
export FFMPEG_CONFIG_FILE
export FFMPEG_CONFIG_EXTRA
export FFMPEG_CONFIG_DEBUG
export EXTRA_CFLAGS
export EXTRA_LDFLAGS

all:
	$(MAKE) all

clean:
	$(MAKE) clean

install:
	$(MAKE) install

release:
	@echo "make a release in: " $(ROOT_FS_DIR)
	$(INSTALL) -d $(ROOT_FS_DIR)/lib
	$(INSTALL) -m 755 ${STAGINGDIR}/lib/libavcodec.so.51.69.0 $(ROOT_FS_DIR)/lib
	$(STRIP) $(ROOT_FS_DIR)/lib/libavcodec.so.51.69.0
	cd $(ROOT_FS_DIR)/lib;  ln -sf libavcodec.so.51.69.0 libavcodec.so
	cd $(ROOT_FS_DIR)/lib;  ln -sf libavcodec.so.51.69.0 libavcodec.so.51
ifeq ($(CONFIG_SAH_LIB_FFMPEG_LIBAVDEVICE_RELEASE),y)
	$(INSTALL) -m 755 ${STAGINGDIR}/lib/libavdevice.so.52.1.0 $(ROOT_FS_DIR)/lib
	$(STRIP) $(ROOT_FS_DIR)/lib/libavdevice.so.52.1.0
	cd $(ROOT_FS_DIR)/lib;  ln -sf libavdevice.so.52.1.0 libavdevice.so
	cd $(ROOT_FS_DIR)/lib;  ln -sf libavdevice.so.52.1.0 libavdevice.so.52
endif
	$(INSTALL) -m 755 ${STAGINGDIR}/lib/libavformat.so.52.21.0 $(ROOT_FS_DIR)/lib
	$(STRIP) $(ROOT_FS_DIR)/lib/libavformat.so.52.21.0
	cd $(ROOT_FS_DIR)/lib;  ln -sf libavformat.so.52.21.0 libavformat.so
	cd $(ROOT_FS_DIR)/lib;  ln -sf libavformat.so.52.21.0 libavformat.so.52
	$(INSTALL) -m 755 ${STAGINGDIR}/lib/libavutil.so.49.10.0 $(ROOT_FS_DIR)/lib
	$(STRIP) $(ROOT_FS_DIR)/lib/libavutil.so.49.10.0
	cd $(ROOT_FS_DIR)/lib;  ln -sf libavutil.so.49.10.0 libavutil.so
	cd $(ROOT_FS_DIR)/lib;  ln -sf libavutil.so.49.10.0 libavutil.so.49

.PHONY: all build clean install release
