# Note: Will only install preloadable lib whitch will be used to bypass uClibc
#       iconv support.
#       At some point it should be done the right way

class Libiconv_OpenSource < OpenSource

  @component="libiconv"
  @source_package="libiconv-1.13.tar.gz"
  @source_dir="libiconv-1.13"
  
  @activation_flag="_APPLI_FLG_LIBICONV_"
  
  @base_dir=Pathname.new(__FILE__).parent.parent
  @configure_options = Hash.new
  @patchlist=["libiconv-1.13_reduction.patch", "libiconv-1.13_auto.patch"]

  @elements_to_install = Hash.new
  @elements_to_install["usr/lib/"]=["usr/lib/preloadable_libiconv.so"]

  @destdir="#{@base_dir}/out/%GCC_MACHINE%/%GCC_VERSION%/%RELEASE%/"

  @configure_options["common"]="\
			--prefix=/                      \
			--exec-prefix=/                 \
			--bindir=/bin                   \
			--libdir=/usr/lib               \
			--includedir=/../../../h        \
                        --disable-static                \
                        --enable-shared                 \
                        "
  
  @configure_options["release"]=""
  
  @configure_options["debug"]=""
  
  @configure_options["sh4-linux"] = "\
			--host=sh4-linux \
			"
  
  @configure_options["mipsel-linux-uclibc"] = " \
			--build=i486-linux-gnu \
			--host=mipsel-linux-uclibc \
			"
  
  @configure_options["i486-linux-gnu"] = ""

  def Libiconv_OpenSource.compile

    sh "make -C #{@base_dir}/#{@source_dir} -f Makefile.devel" rescue ""
    super.compile rescue ""

  end

end
