ifeq ($(CC),gcc)
  NTF3G_FULL_CONFIGURATION:=$(NTFS3G_FULL_CONFIGURATION) --host=i386-linux --enable-shared --with-gnu-ld --disable-ldconfig 
else
  NTFS3G_FULL_CONFIGURATION:=$(NTFS3G_FULL_CONFIGURATION) --host=mips-linux-uclibc --disable-ldconfig
endif

all: config build
	

config:
	@echo "ntfs-3g full config : " $(NTFS3G_FULL_CONFIGURATION)
	( cd src && ./configure  $(NTFS3G_FULL_CONFIGURATION) CPPFLAGS=-I$(HARDCO_KERNEL_DIR)/include )

clean:
	@echo "Cleaning ntfs-3g"
	if [ -e src/Makefile ]; then  $(MAKE) -C src -f Makefile clean distclean; fi

build:
	@echo "Building ntfs-3g to $(STAGINGDIR)"
	$(MAKE) -C src -f Makefile DESTDIR=$(STAGINGDIR) CPPFLAGS=-I$(HARDCO_KERNEL_DIR)/include

install:
	@echo "Install NTFS-3G to: " $(STAGINGDIR)
	$(MAKE) -C src -f Makefile install DESTDIR=$(STAGINGDIR)

release:
	@echo "Release NTFS-3G to" $(ROOT_FS_DIR)

	$(INSTALL) -d $(ROOT_FS_DIR)/lib
	$(INSTALL) -d $(ROOT_FS_DIR)/usr/bin
	$(INSTALL) -d $(ROOT_FS_DIR)/sbin
	$(INSTALL) -d $(ROOT_FS_DIR)/bin

	cp -dp $(STAGINGDIR)/lib/libntfs-3g.so* $(ROOT_FS_DIR)/lib/
	$(INSTALL) -m 0755 $(STAGINGDIR)/usr/local/bin/ntfs-3g.probe $(ROOT_FS_DIR)/usr/bin/ntfs-3g.probe
	cp -dp $(STAGINGDIR)/sbin/mount.ntfs-3g $(ROOT_FS_DIR)/sbin/mount.ntfs-3g
	$(INSTALL) -m 0755 $(STAGINGDIR)/bin/ntfs-3g $(ROOT_FS_DIR)/bin/ntfs-3g

.PHONY: config clean build install release
