#CONCURRENCY_LEVEL ?= $(shell /bin/grep ^processor /proc/cpuinfo | /usr/bin/wc -l)
CONCURRENCY_LEVEL=1

include $(STAGINGDIR)/components.config
include $(STAGINGDIR)/config/kernel.config

export CFLAGS LDFLAGS

ifeq ($(CONFIG_BUILD_LEGACY_RELEASEDIR),y)
	RELEASEDIR:=$(RELEASEDIR)/..
	@echo "New RELEASEDIR=$(RELEASEDIR)"
endif


all: modules kernel.img

.config: $(STAGINGDIR)/config/kernel.config
	cp --no-preserve=mode $^ $@

menuconfig:
	$(MAKE) menuconfig

oldconfig:
	$(MAKE) oldconfig

include/linux/autoconf.h: .config oldconfig

kernel.img: modules vmlinux
	$(MAKE) -j$(CONCURRENCY_LEVEL) adiimage V=1

modules: vmlinux
	$(MAKE) -j$(CONCURRENCY_LEVEL) modules V=1

vmlinux: include/linux/autoconf.h
	$(MAKE) -j$(CONCURRENCY_LEVEL) vmlinux V=1

install:
	-$(INSTALL) vmlinux System.map .config kernel.img $(STAGINGDIR)
	$(MAKE) modules_install INSTALL_MOD_PATH=$(STAGINGDIR)
	-$(INSTALL) -d $(STAGINGDIR)/include
	-$(INSTALL) -d $(STAGINGDIR)/include/asm
	-$(INSTALL) -d $(STAGINGDIR)/include/inc
	-$(INSTALL) -d $(STAGINGDIR)/include/inc/atmeng
	-$(INSTALL) -d $(STAGINGDIR)/include/mtd
	-$(INSTALL) -d $(STAGINGDIR)/include/linux
	-$(INSTALL) -d $(STAGINGDIR)/include/linux/fusiv_src/kernel/drivers/ipqos
	-$(INSTALL) -d $(STAGINGDIR)/include/mgmt
	-$(INSTALL) -d $(STAGINGDIR)/include/drivers/pppoer
	-$(INSTALL) -d $(STAGINGDIR)/include/vtag
	-$(INSTALL) -d $(STAGINGDIR)/include/ethdriver/common
	-$(INSTALL) -d $(STAGINGDIR)/include/acl_ap	
	-$(INSTALL) -d $(STAGINGDIR)/include/ap_code/inc/adsl
	-$(INSTALL) -d $(STAGINGDIR)/include/inc/adsl
	-$(INSTALL) -d $(STAGINGDIR)/include/ap_code/inc
	-$(INSTALL) -d $(STAGINGDIR)/include/ap_code/vdsl_ptm/ptminclude/
	-$(INSTALL) -d $(STAGINGDIR)/include/ap_code/inc/atmeng
	-$(INSTALL) -d $(STAGINGDIR)/include/ap_code/ethdriver/common
	-$(INSTALL) -d $(STAGINGDIR)/include/ap_code/ethdriver/phy
	-$(INSTALL) -d $(STAGINGDIR)/include/drivers/inc
	-$(INSTALL) -d $(STAGINGDIR)/include/drivers/acl_ap
	-$(INSTALL) -d $(STAGINGDIR)/include/drivers/switch/icplus
	-$(INSTALL) -d $(STAGINGDIR)/include/drivers/switch/atheros
	-$(INSTALL) -d $(STAGINGDIR)/include/ap_code/inc/netpro/vx185
	-$(INSTALL) -p fusiv_src/kernel/ap_code/inc/sysconf.h $(STAGINGDIR)/include/inc
	-$(INSTALL) -p fusiv_src/kernel/ap_code/inc/sysconf.h $(STAGINGDIR)/include/ap_code/inc
	-$(INSTALL) -p fusiv_src/kernel/ap_code/inc/sysconf.h $(STAGINGDIR)/include
	# Install BSP headers.
	-$(INSTALL) -d $(STAGINGDIR)/include/linux/bsp
	-$(INSTALL) -p include/linux/bsp/*.h $(STAGINGDIR)/include/linux/bsp
	-$(INSTALL) -p fusiv_src/kernel/drivers/adsl/mgmt/atmgdef.h $(STAGINGDIR)/include/mgmt
	-$(INSTALL) -p fusiv_src/kernel/drivers/adsl/mgmt/adslmode.h $(STAGINGDIR)/include/mgmt
	-$(INSTALL) -p fusiv_src/kernel/ap_code/inc/atmeng/atmlib.h $(STAGINGDIR)/include/ap_code/inc/atmeng
	-$(INSTALL) -p fusiv_src/kernel/ap_code/inc/atmeng/wrr.h $(STAGINGDIR)/include/ap_code/inc/atmeng
	-$(INSTALL) -p fusiv_src/kernel/drivers/pppoer/ppprelaylib.h $(STAGINGDIR)/include/drivers/pppoer
	-$(INSTALL) -p fusiv_src/kernel/drivers/pppoer/ppprelayios.h $(STAGINGDIR)/include/drivers/pppoer
	-$(INSTALL) -p fusiv_src/kernel/drivers/pppoer/pppoecommon.h $(STAGINGDIR)/include/drivers/pppoer
	-$(INSTALL) -p fusiv_src/kernel/drivers/inc/stackios.h $(STAGINGDIR)/include/drivers/inc
	-$(INSTALL) -p fusiv_src/kernel/drivers/inc/switchvlan.h $(STAGINGDIR)/include/drivers/inc
	-$(INSTALL) -p fusiv_src/kernel/drivers/inc/atm_adi.h $(STAGINGDIR)/include/drivers/inc
	-$(INSTALL) -p fusiv_src/kernel/drivers/switch/icplus/icplus_common.h $(STAGINGDIR)/include/drivers/switch/icplus
	-$(INSTALL) -p fusiv_src/kernel/drivers/switch/atheros/athr83xx_struc.h $(STAGINGDIR)/include/drivers/switch/atheros
	-$(INSTALL) -p fusiv_src/kernel/drivers/switch/atheros/athr83xx_regs.h $(STAGINGDIR)/include/drivers/switch/atheros
	-$(INSTALL) -p fusiv_src/kernel/drivers/acl_ap/aclapidef.h $(STAGINGDIR)/include/drivers/acl_ap
	-$(INSTALL) -p fusiv_src/kernel/drivers/inc/emac.h $(STAGINGDIR)/include/drivers/inc
	-$(INSTALL) -p fusiv_src/kernel/ap_code/ethdriver/common/indlinkstats.h $(STAGINGDIR)/include/ap_code/ethdriver/common
	-$(INSTALL) -p fusiv_src/kernel/ap_code/ethdriver/common/indlinksetup.h $(STAGINGDIR)/include/ap_code/ethdriver/common
	-$(INSTALL) -p fusiv_src/kernel/ap_code/ethdriver/common/indlinkstate.h $(STAGINGDIR)/include/ap_code/ethdriver/common
	-$(INSTALL) -p fusiv_src/kernel/ap_code/ethdriver/common/indphy.h $(STAGINGDIR)/include/ethdriver/common
	-$(INSTALL) -p fusiv_src/kernel/ap_code/ethdriver/common/indlinkstate.h $(STAGINGDIR)/include/ethdriver/common
	-$(INSTALL) -p fusiv_src/kernel/ap_code/ethdriver/common/indlinksetup.h $(STAGINGDIR)/include/ethdriver/common
	-$(INSTALL) -p fusiv_src/kernel/ap_code/ethdriver/common/ethdefs.h $(STAGINGDIR)/include/ethdriver/common
	-$(INSTALL) -p fusiv_src/kernel/ap_code/ethdriver/phy/ieeephy.h $(STAGINGDIR)/include/ap_code/ethdriver/phy
	-$(INSTALL) -p fusiv_src/kernel/ap_code/vdsl_ptm/ptminclude/fusiv_vdsl_common.h $(STAGINGDIR)/include/ap_code/vdsl_ptm/ptminclude
	-$(INSTALL) -p fusiv_src/kernel/ap_code/vdsl_ptm/ptminclude/fusiv_avdsl_ioctl.h $(STAGINGDIR)/include/ap_code/vdsl_ptm/ptminclude
	-$(INSTALL) -p include/linux/autoconf.h $(STAGINGDIR)/include/linux
	-$(INSTALL) -p arch/mips/include/asm/addrspace.h $(STAGINGDIR)/include/asm
	-$(INSTALL) -p arch/mips/include/asm/mach-generic/spaces.h $(STAGINGDIR)/include
	-$(INSTALL) -p include/linux/const.h $(STAGINGDIR)/include/linux
	-$(INSTALL) -p fusiv_src/kernel/ap_code/inc/adsl/adsllib.h $(STAGINGDIR)/include/ap_code/inc/adsl
	-$(INSTALL) -p fusiv_src/kernel/ap_code/inc/adsl/adsllibint.h $(STAGINGDIR)/include/ap_code/inc/adsl
	-$(INSTALL) -p fusiv_src/kernel/drivers/vtag/vtag.h $(STAGINGDIR)/include/vtag
	-$(INSTALL) -p fusiv_src/kernel/drivers/inc/atm_adi.h $(STAGINGDIR)/include/drivers/inc
	-$(INSTALL) -p fusiv_src/kernel/drivers/acl_ap/aclapidef.h $(STAGINGDIR)/include/acl_ap
	-$(INSTALL) -p fusiv_src/kernel/ap_code/inc/atmeng/* $(STAGINGDIR)/include/inc/atmeng
	-$(INSTALL) -p fusiv_src/kernel/drivers/ipqos/fusivTC.h $(STAGINGDIR)/include/linux/fusiv_src/kernel/drivers/ipqos
	-$(INSTALL) -p fusiv_src/kernel/drivers/ipqos/wfqlib.h $(STAGINGDIR)/include/linux/fusiv_src/kernel/drivers/ipqos
	-$(INSTALL) -p fusiv_src/kernel/drivers/inc/* $(STAGINGDIR)/include/inc
	-$(INSTALL) -p fusiv_src/kernel/ap_code/inc/adsl/* $(STAGINGDIR)/include/inc/adsl
	-$(INSTALL) -p include/mtd/*.h $(STAGINGDIR)/include/mtd/
	-$(INSTALL) -p fusiv_src/kernel/ap_code/inc/netpro/vx185/commonconfig.h $(STAGINGDIR)/include/ap_code/inc/netpro/vx185
	-$(INSTALL) -p fusiv_src/kernel/ap_code/inc/netpro/vx185/classifierhw.h $(STAGINGDIR)/include/ap_code/inc/netpro/vx185
# Install AVDSL firmware.
ifneq ($(CONFIG_SAH_HAL_AVDSLD), y) 
	-$(INSTALL) -d $(STAGINGDIR)/bin
	-$(INSTALL) -m 444 fusiv_src/avdsl_fw/L1CODE.BIN $(STAGINGDIR)/bin
	-$(INSTALL) -m 444 fusiv_src/avdsl_fw/cmvs.txt $(STAGINGDIR)/bin
else
	-$(INSTALL) -d $(STAGINGDIR)/bin
ifeq ($(CONFIG_FUSIV_VX185), y) 
	-$(INSTALL) -m 444 fusiv_src/avdsl_fw/Code_VX185.BIN $(STAGINGDIR)/bin
endif
ifeq ($(CONFIG_FUSIV_VX180), y) 
	-$(INSTALL) -m 444 fusiv_src/avdsl_fw/Code_VX180.BIN $(STAGINGDIR)/bin
endif
endif

release:
	$(MAKE) modules_install INSTALL_MOD_PATH=$(ROOT_FS_DIR)
	-$(INSTALL) $(STAGINGDIR)/vmlinux $(RELEASEDIR)
	-$(INSTALL) $(STAGINGDIR)/System.map $(RELEASEDIR)
	-$(INSTALL) $(STAGINGDIR)/kernel.img $(RELEASEDIR)
# Install AVDSL firmware.
ifneq ($(CONFIG_SAH_HAL_AVDSLD), y) 
	-$(INSTALL) -d $(ROOT_FS_DIR)/bin
	-$(INSTALL) -m 444 $(STAGINGDIR)/bin/L1CODE.BIN $(ROOT_FS_DIR)/bin
	-$(INSTALL) -m 444 $(STAGINGDIR)/bin/cmvs.txt $(ROOT_FS_DIR)/bin
else
	-$(INSTALL) -d $(ROOT_FS_DIR)/bin
ifeq ($(CONFIG_FUSIV_VX185), y) 
	-$(INSTALL) -m 444 $(STAGINGDIR)/bin/Code_VX185.BIN $(ROOT_FS_DIR)/bin
endif
ifeq ($(CONFIG_FUSIV_VX180), y) 
	-$(INSTALL) -m 444 $(STAGINGDIR)/bin/Code_VX180.BIN $(ROOT_FS_DIR)/bin
endif
endif


build_package:
	rm -rf $(COMP_PACKAGE_DIR)
	-$(INSTALL) -d $(COMP_PACKAGE_DIR)
	make -f Component.mk release ROOT_FS_DIR=$(COMP_PACKAGE_DIR)

release_package:
	-$(INSTALL) -d $(ROOT_FS_DIR)
	cp -af $(COMP_PACKAGE_DIR)/* $(ROOT_FS_DIR)
	-$(INSTALL) $(STAGINGDIR)/vmlinux $(RELEASEDIR)
	-$(INSTALL) $(STAGINGDIR)/System.map $(RELEASEDIR)
	-$(INSTALL) $(STAGINGDIR)/kernel.img $(RELEASEDIR)

clean:
	$(MAKE) mrproper
	rm -rf kernel.img

.PHONY: all modules install release clean vmlinux oldconfig menuconfig
