/*
 * ============================================================================
 *
 * Copyright : (c) 2005 SAGEM SA - Site Velizy - URD2
 *
 * The information and source code contained herein is the exclusive
 * property of SAGEM and may not be disclosed, examined, or
 * reproduced in whole or in part without explicit written authorization
 * of the company.
 *
 * ============================================================================
 */

/**
 * \file bsp_lan.c Bsp lan functions
 *
 * This file contain all Bsp Lan functions.
 */

/*
 * Includes
 * ~~~~~~~~
 */

#include "bsp_pri.h"

/*
 * Functions
 * ~~~~~~~~~~
 */

/** Get lan cnx. */
pBsp_board_lan_s	bsp_get_board_lan()
{
	/* Chech reference */
	if (bsp_base.Board.Cur.pInfo == (pBsp_board_info_all_s)0) {
		printk(	"%s: WARNING -> Current reference is NULL\n",
				__FUNCTION__);

		/* Error */
		return((pBsp_board_lan_s)0);
	}

	/* Ok */
	return(&(bsp_base.Board.Cur.pInfo->Lan));
}
EXPORT_SYMBOL(bsp_get_board_lan);

int bsp_reset_gpio_lan(void)
{
	pBsp_board_lan_s	_pBsp_lan		= bsp_get_board_lan();
	bsp_gpio_name_e	_gpio_name	= BSP_Gpio_name_reserved;
	int				_i;

	/* Check */
	if (_pBsp_lan == (pBsp_board_lan_s)0) {
		printk(	"%s: Reference on lan is null !\n",
				__FUNCTION__);

		return(-1);
	}

	/* All */
	for (_i = 0; _i < BSP_LAN_PHY_MAX + BSP_LAN_SWITCH_MAX; _i++) {
		_gpio_name = _pBsp_lan->all[_i];

		/* End ? */
		if (_gpio_name == BSP_Gpio_name_reserved) {
			/* Out */
			break;
		}

		/* Reset */
		{
			/* Reset Gpio */
			bsp_gpio_set_state(	_gpio_name,
							BSP_Gpio_state_unset);
		
			udelay(15);
	
			/* Set Gpio */
			bsp_gpio_set_state(	_gpio_name,
							BSP_Gpio_state_set);
		
			udelay(100);
		}
	}

	/* Ok */
	return(0);
}

// vim:ts=5:
