/*
 * ============================================================================
 *
 * Copyright : (c) 2005 SAGEM SA - Site Velizy - URD2
 *
 * The information and source code contained herein is the exclusive
 * property of SAGEM and may not be disclosed, examined, or
 * reproduced in whole or in part without explicit written authorization
 * of the company.
 *
 * ============================================================================
 */

/**
 * \file bsp_usb.c Bsp Usb functions
 *
 * This file contain all Bsp Usb functions.
 */

/*
 * Includes
 * ~~~~~~~~
 */

#include "bsp_pri.h"

/*
 * Functions
 * ~~~~~~~~~~
 */

/** Get usb. */
pBsp_board_usb_s	bsp_get_board_usb(	void)
{
	/* Chech reference */
	if (bsp_base.Board.Cur.pInfo == (pBsp_board_info_all_s)0) {
		printk(	"%s: WARNING -> Current reference is NULL\n",
				__FUNCTION__);

		return((pBsp_board_usb_s)0);
	}

	/* Ok */
	return(&(bsp_base.Board.Cur.pInfo->Usb));
}
EXPORT_SYMBOL(bsp_get_board_usb);

/* Reset Usb Gpio */
int bsp_reset_gpio_usb(void)
{
	pBsp_board_usb_s	_pBsp_usb		= bsp_get_board_usb();
	bsp_gpio_name_e	_gpio_name	= BSP_Gpio_name_reserved;
	int				_i;

	/* Check */
	if (_pBsp_usb == (pBsp_board_usb_s)0) {
		printk(	"%s: Reference on usb is null !\n",
				__FUNCTION__);

		return(-1);
	}

	/* All Hub */
	for (_i = 0; _i < BSP_USB_HUB_MAX; _i++) {
		_gpio_name = _pBsp_usb->Hub.all[_i];

		/* End ? */
		if (_gpio_name == BSP_Gpio_name_reserved) {
			/* Out */
			break;
		}

		/* Reset */
		{
			/* Unset Gpio */
			bsp_gpio_set_state(	_gpio_name,
							BSP_Gpio_state_unset);
		
			udelay(1000);

			/* Set Gpio */
			bsp_gpio_set_state(	_gpio_name,
							BSP_Gpio_state_set);
		
			udelay(1000);
		}
	}

	/* All Master */
	for (_i = 0; _i < BSP_USB_MASTER_MAX; _i++) {
		_gpio_name = _pBsp_usb->Master.all[_i];

		/* End ? */
		if (_gpio_name == BSP_Gpio_name_reserved) {
			/* Out */
			break;
		}

		/* Reset */
		{
			/* Set Gpio */
			bsp_gpio_set_state(	_gpio_name,
							BSP_Gpio_state_set);
		}
	}

	/* All Slave */
	for (_i = 0; _i < BSP_USB_SLAVE_MAX; _i++) {
		_gpio_name = _pBsp_usb->Slave.all[_i];

		/* End ? */
		if (_gpio_name == BSP_Gpio_name_reserved) {
			/* Out */
			break;
		}

		/* Reset */
		{
			/* Set Gpio */
			bsp_gpio_set_state(	_gpio_name,
							BSP_Gpio_state_set);
		}
	}

	/* Ok */
	return(0);
}

// vim:ts=5:
