/*
 * ============================================================================
 *
 * Copyright : (c) 2005 SAGEM SA - Site Velizy - URD2
 *
 * The information and source code contained herein is the exclusive
 * property of SAGEM and may not be disclosed, examined, or
 * reproduced in whole or in part without explicit written authorization
 * of the company.
 *
 * ============================================================================
 */

/**
 * \file bsp_voice.c Bsp Voice functions
 *
 * This file contain all Bsp Voice functions.
 */

/*
 * Includes
 * ~~~~~~~~
 */

#include "bsp_pri.h"

/*
 * Functions
 * ~~~~~~~~~~
 */

/** Get voice. */
pBsp_board_voice_s	bsp_get_board_voice(	void)
{
	/* Chech reference */
	if (bsp_base.Board.Cur.pInfo == (pBsp_board_info_all_s)0) {
		printk(	"%s: WARNING -> Current reference is NULL\n",
				__FUNCTION__);

		return((pBsp_board_voice_s)0);
	}

	/* Ok */
	return(&(bsp_base.Board.Cur.pInfo->Voice));
}
EXPORT_SYMBOL(bsp_get_board_voice);

/* Reset Voice */
int bsp_reset_gpio_voice(void)
{
	pBsp_board_voice_s	_pBsp_voice	= bsp_get_board_voice();
	bsp_gpio_name_e	_gpio_name	= BSP_Gpio_name_reserved;
	int				_i;

	/* Check */
	if (_pBsp_voice == (pBsp_board_voice_s)0) {
		printk(	"%s: Reference on voice is null !\n",
				__FUNCTION__);

		return(-1);
	}

	/* All Fxs */
	for (_i = 0; _i < BSP_VOICE_FXS_MAX; _i++) {
		_gpio_name = _pBsp_voice->Fxs.all[_i];

		/* End ? */
		if (_gpio_name == BSP_Gpio_name_reserved) {
			/* Out */
			break;
		}


		/* Reset. */
		{
			/* Unset */
			bsp_gpio_set_state(	_gpio_name,
							BSP_Gpio_state_unset);
		
			/* Delay */
			mdelay(1000);
		
			/* Set */
			bsp_gpio_set_state(	_gpio_name,
							BSP_Gpio_state_set);
		
			/* Delay */
			mdelay(1000);
		}
	}

	/* All Fxo */
	for (_i = 0; _i < BSP_VOICE_FXO_MAX; _i++) {
		_gpio_name = _pBsp_voice->Fxo.all[_i];

		/* End ? */
		if (_gpio_name == BSP_Gpio_name_reserved) {
			/* Out */
			break;
		}


		/* Reset. */
		{
			/* Unset */
			bsp_gpio_set_state(	_gpio_name,
							BSP_Gpio_state_unset);
		
			/* Delay */
			mdelay(1000);
		
			/* Set */
			bsp_gpio_set_state(	_gpio_name,
							BSP_Gpio_state_set);
		
			/* Delay */
			mdelay(1000);
		}
	}

	/* Ok */
	return(0);
}

// vim:ts=5:
