#include <linux/init.h>
#include <linux/fs.h>
#include <linux/bsp/bsp_but.h>

#include "khco_button_api.h"

extern int button_init(void);

// key structure of button-GPIO mapping
typedef struct _kbutton_pair_map_t
{
	BOARD_BUTTON_NAME name;
	unsigned int mask;
} kbutton_pair_map_t, *pkbutton_pair_map_t;

//#define GPIO_DIR_LOW	0xFFFE0084
//#define GPIO_DATA_LOW	0xFFFE008C
//#define GPIO_DIR_HIGH	0xFFFE0084
//#define GPIO_DATA_HIGH	0xFFFE008C

//#define GPIO_NUM_TO_MASK_LOW(X)		(((X) < 32)? (1 << (X)) : 0)
//#define GPIO_NUM_MAX_BITS_MASK_HIGH	0x3f
//#define GPIO_NUM_TO_MASK_HIGH(X)	(((X)  >= 32) ? ((1 << (X-32)) & GPIO_NUM_MAX_BITS_MASK_HIGH) : (0))

/* to set the gpio mapping of buttons */
kbutton_pair_map_t kbutton_pair_mapping[] =
{
	[0] = {
		.name = kButtonReset,
		.mask = 0
	},
	[1] = {
		.name = kButtonReboot,
		.mask = 1
	},
	[2] = {
		.name = kButtonPairing,
		.mask = 2
	},
	[3] = {
		.name = kButtonEnd
	}
};

/* to get the state of a specific button in kernel mode */
BOARD_BUTTON_STATE
kbutton_hw_get_state(BOARD_BUTTON_NAME button)
{
        int ret = -1;

	ret = kSysGetButtonState(button);

return ret;
}

/* to init gpio settings for button in kernel mode */
void
kbutton_hw_init(void)
{
	// TODO:
	int ret = -1;
	ret = button_init();
	if(ret) printk(" button_init failed \n");
}

