#ifndef __LB_BUTTON_H__
#define __LB_BUTTON_H__

/*
 * Additional interface for event-driven Button API
 * (Used on Livebox)
 */

#ifdef __KERNEL__
#include <linux/time.h>
#endif

#ifdef __cplusplus
extern "C" {
#endif

typedef enum {
	evButtonPushed,
	evButtonReleased,
	evButtonKeptPushed,
	evButtonEnd
} BOARD_BUTTON_EVENT;

typedef struct lb_button_trigger {
	BOARD_BUTTON_EVENT event;
	unsigned long data;
} BUTTON_TRIGGER_INFO;

typedef struct lb_button_event {
	BOARD_BUTTON_EVENT event;
	struct timeval stamp;
} BUTTON_EVENT_INFO;

#define LBBUTTON_ADD_TRIGGER            _IOR('L', 0, struct lb_button_trigger)
#define LBBUTTON_REMOVE_TRIGGER         _IO('L', 1)
#define LBBUTTON_GET_STATE              _IO('L', 2)

#ifdef __cplusplus
}
#endif

#endif /* LB_BUTTON_H__ */

