#include <linux/init.h>
#include <linux/fs.h>
#include <linux/module.h>
#include <linux/cdev.h>
#include <asm/uaccess.h>

#include "led_local.h"
#include "led_linux.h"

static struct cdev led_cdev;
static void *linuxled_ctx;

extern int led_init(void);

static int
led_open(struct inode *inodp, struct file *filp)
{
	// TODO

	return 0;
}

static ssize_t
led_read(struct file *filp, char __user *buffer, size_t count, loff_t *ppos)
{
	// TODO

	return 0;
}

static int
led_ioctl(struct inode *inodp, struct file *filp, unsigned int cmd, unsigned long arg)
{
	int ret = 0;
	kled_param_t param;
	
	
	switch (cmd)
	{
		case BOARD_IOCTL_LED_CTRL:
			if (copy_from_user((void*)&param, (void*)arg, sizeof(param)) == 0) {
				kled_set_state((BOARD_LED_NAME)param.name, (BOARD_LED_STATE)param.state, param.freq_on, param.freq_off);
				ret = 0;
			}
		break;

		case BOARD_IOCTL_LED_STATUS:
			if (copy_from_user((void*)&param, (void*)arg, sizeof(param)) == 0) {
				kled_get_state((BOARD_LED_NAME)param.name, (BOARD_LED_STATE *)&param.state) ;
					
				if (copy_to_user((void*)arg, (void*)&param, sizeof(param)) == 0)
				{
					ret = 0;
				}
			}
		break;	

		default:
			ret = -EINVAL;
			//printk("led_ioctl: invalid command %x, cmd %d.\n", cmd, _IOR_NR(cmd));
			break;
	}

	return ret;
}

static int
led_release(struct inode *inodp, struct file *filp)
{
	// TODO

	return 0;
}

static struct file_operations led_fops =
{
	.open    = led_open,
	.read    = led_read,
	.ioctl   = led_ioctl,
	.release = led_release,
    .owner   = THIS_MODULE,
};

static void *linuxled_ctx;

static int __init
lb_led_init(void)
{
    int err = 0;
	cdev_init(&led_cdev, &led_fops);
	if ( (err = cdev_add(&led_cdev, MKDEV(LED_DRV_MAJOR, 0), 1)) < 0) {
	    printk(" errno %d", err);
        panic("Couldn't add   /dev/" LED_DRV_DEVICE "\n");
    }
	if ( (err = register_chrdev_region(MKDEV(LED_DRV_MAJOR, 0), 1, LED_DRV_DEVICE)) < 0) {
	    printk(" errno %d", err);
//		panic("Couldn't register   /dev/" LED_DRV_DEVICE "\n");
    }

	led_init();

	kled_init();
	linuxled_ctx = sah_linuxleds_register(kLedEnd);

	return 0;
}

static void __exit
lb_led_exit(void)
{
	//TODO:
	sah_linuxleds_unregister(linuxled_ctx);	
}

module_init(lb_led_init);
module_exit(lb_led_exit);

MODULE_LICENSE("GPL");
MODULE_AUTHOR("Soft At Home");
MODULE_DESCRIPTION("LED driver");
