/*
* This file adds functionality to iptable command by providing structure elements to configure ikanos fusiv QOS modules (fusivTC)
*
* Copyright © Ikanos Communications 2008-2013.
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public License
* as published by the Free Software Foundation; either version
* 2 of the License, or (at your option) any later version.
*
*/
#ifndef __FUSIVTC_H_target
#define __FUSIVTC_H_target
#include <linux/netfilter_ipv4/ipt_DSCP.h>
#if !IS_VX185
/* Type of mapping macros */
#define   IPQOS_TOS             0x1
#define   IPQOS_DSCP            0x2
#define   IPQOS_COS             0x4
#define   IPQOS_RECV_COS        0x5
#endif

/* Fusiv TC Information Structure  */
struct fusivtc_target_info{
	unsigned char     ucPriority;          /* Priority Class          */

	unsigned char     markingInfo;		     /* Marking Information 		*/		   

	unsigned char     marking_priority;    /* Marking Priority        */
	unsigned char     marking_cos_priority;/* COS Marking Priority    */

	unsigned char     mappingInfo;         /* Mapping Information     */

	unsigned char     rateControl;         /* Rate Control Information*/

  unsigned char     remarkInfo;          /* Priority Conversions    */
  /* Configuration Information required for Rate Control */
	unsigned int      confAssuredBW;       /* Assured BW.                    */
	unsigned int      confMaxBW;           /* Maximum Bandwidth.             */

	/* Information required for the Rate Control Implementaion */
	unsigned int      assuredTokens;       /* Assured Tokens.                */
	unsigned int      maxTokens;           /* Maximum tokens.                */
	unsigned int      timeStamp;           /* Time Stamp.                    */

  /* Statistics */
	unsigned int      greenPkts;           /* Total Number of Green Packets  */
	unsigned int      greenBytes;          /* Total Number of Green Bytes    */
	unsigned int      yellowPkts;          /* Total Number of Yellow Packets */
	unsigned int      yellowBytes;         /* Total number of Yello bytes.   */
	unsigned int      redPkts;             /* Total number of Red Packets.   */
	unsigned int      redBytes;            /* Total number of red bytes.     */
	unsigned int      dscp_info;           /*  DSCP Configuration Info */
        struct            ipt_DSCP_info dinfo; /* DSCP value */
};

#endif /* Fusiv TC */

