/*
 * ============================================================================
 *
 * Copyright : (c) 2005 SAGEM SA - Site Velizy - URD2
 *
 * The information and source code contained herein is the exclusive
 * property of SAGEM and may not be disclosed, examined, or
 * reproduced in whole or in part without explicit written authorization
 * of the company.
 *
 * ============================================================================
 */

#ifndef __BSP_BOOT_H__
#define __BSP_BOOT_H__

/**
 * \file bsp_boot.h Bsp Boot description.
 *
 * This file allow to describe Bsp Boot.
*/

/*
 * Typedefs
 * ~~~~~~~~
 */

/** \name bsp_env_boot struct Typedefs.
 */
/*@{*/
/** \link bsp_env_boot_str bsp_env_boot struct \endlink typedef. */
typedef struct bsp_env_boot_str				bsp_env_boot_s;
/** \link bsp_env_boot_str bsp_env_boot struct \endlink pointer typedef. */
typedef struct bsp_env_boot_str				*pBsp_env_boot_s;
/*@}*/

/**
 * \name Enum typedefs.
 */
/*@{*/
/** Typedef on enum bsp_boot_recovery force_enu. */
typedef enum bsp_boot_recovery_force_enu		bsp_boot_recovery_force_e;
/*@}*/

/*
 * Enums
 * ~~~~~
 */

/** Type Boot Force. */
enum bsp_boot_recovery_force_enu {
	/** Normal. */
	BSP_Boot_recovery_force_normal,

	/** Rescue. */
	BSP_Boot_recovery_force_rescue,

	/** Bootp. */
	BSP_Boot_recovery_force_bootp,

	/** Max. */
	BSP_Boot_recovery_force_max,

	/** Unknown. */
	BSP_Boot_recovery_force_unknown	= 0xff,
};

/*
 * Structs
 * ~~~~~~~
 */

#ifdef __KERNEL__
/** Bsp_env_boot_str.
 *
 * 	This struct manage Boot Information.
 */
struct bsp_env_boot_str {
	/** Struct Recovery. */
	struct {
		/** Read/write semaphore. */
		struct rw_semaphore			sem;

		/** Force. */
		bsp_boot_recovery_force_e	force;
		
		/** Min. */
		int						min;
	
		/** Max. */
		int						max;
	}Recovery;
};
#endif

/*
 * Functions
 * ~~~~~~~~~
 */

/** Get  boot recovery force. */
bsp_boot_recovery_force_e bsp_get_boot_recovery_force(	void);

#endif

// vim:ts=5:
