/*
 * ============================================================================
 *
 * Copyright : (c) 2005 SAGEM SA - Site Velizy - URD2
 *
 * The information and source code contained herein is the exclusive
 * property of SAGEM and may not be disclosed, examined, or
 * reproduced in whole or in part without explicit written authorization
 * of the company.
 *
 * ============================================================================
 */

#ifndef __BSP_KRNOPT_H__
#define __BSP_KRNOPT_H__

/**
 * \file bsp_krnopt.h Bsp Kernel Option description.
 *
 * This file allow to describe Bsp Kernel Option.
*/

/*
 * Includes
 * ~~~~~~~~
 */

#include <linux/bsp/bsp_firmware.h>
#include <linux/bsp/bsp_board.h>

/*
 * Typedefs
 * ~~~~~~~~
 */

#ifdef __KERNEL__

/**
 * \name bsp_env_krnopt typedefs.
 */
/*@{*/
/** Typedef on struct bsp_env_krnopt_str. */
typedef struct bsp_env_krnopt_str			bsp_env_krnopt_s;
/** Typedef pointer on struct bsp_env_krnopt_str. */
typedef struct bsp_env_krnopt_str			*pBsp_env_krnopt_s;
/*@}*/

#endif

/*
 * Enums
 * ~~~~~
 */

/*
 * Structs
 * ~~~~~~~
 */

#ifdef __KERNEL__

/** Struct bsp_env_krnopt. */
struct bsp_env_krnopt_str {
	/** Type Firware. */
	bsp_firmware_type_e				typeFirmware;

	/** My Fs Start. */
	unsigned int					myfs_start;

	/** My Fs Size. */
	unsigned int					myfs_size;

	/** Operational Start. */
	unsigned int					operational_start;

	/** Rescue Start. */
	unsigned int					rescue_start;
};

#endif

/*
 * Functions
 * ~~~~~~~~~
 */

#ifdef __KERNEL__

/** Get Krn Opt. */
pBsp_env_krnopt_s bsp_get_env_krnopt(			void);

#endif

#endif

// vim:ts=5:
