/*
 * ============================================================================
 *
 * Copyright : (c) 2009 SAGEM SA - Site Velizy - URD2
 *
 * The information and source code contained herein is the exclusive
 * property of SAGEM and may not be disclosed, examined, or
 * reproduced in whole or in part without explicit written authorization
 * of the company.
 *
 * ============================================================================
 */

#ifndef __BSP_USB_H__
#define __BSP_USB_H__

/**
 * \file bsp_usb.h Bsp description for manage USB.
 *
 * This file allow to describe Bsp Usb Public.
*/

#ifdef __KERNEL__

/*
 * Defines
 * ~~~~~~~~
 */

/** \name Usb Hub Max.
 */
/*@{*/
/** Usb Hub MAX. */
#define	BSP_USB_HUB_MAX			1

/** Usb Master MAX. */
#define	BSP_USB_MASTER_MAX			2

/** Usb Slave MAX. */
#define	BSP_USB_SLAVE_MAX			1
/*@}*/


/*
 * Typedefs
 * ~~~~~~~~
 */

/** \name bsp_board_usb struct Typedefs.
 */
/*@{*/
/** \link bsp_board_usb_str bsp_board_usb struct \endlink typedef. */
typedef struct bsp_board_usb_str			bsp_board_usb_s;
/** \link bsp_board_usb_str bsp_board_usb struct \endlink pointer typedef. */
typedef struct bsp_board_usb_str			*pBsp_board_usb_s;
/*@}*/

/*
 * Structs
 * ~~~~~~~
 */

/** Bsp_board_usb_str.
 *
 * 	This struct manage Board Usb Information.
 */
struct bsp_board_usb_str {
	/** Struct manage Hub. */
	struct {
		/* Nb. */
		int						nb;
	
		/** All Name. */
		bsp_gpio_name_e			all[BSP_USB_HUB_MAX + 1];
	}Hub;

	/** Struct manage master. */
	struct {
		/** Nb. */
		int						nb;
	
		/** All Name. */
		bsp_gpio_name_e			all[BSP_USB_MASTER_MAX + 1];
	}Master;

	/** Struct manage slave. */
	struct {
		/** Nb. */
		int						nb;
	
		/** All Name. */
		bsp_gpio_name_e			all[BSP_USB_SLAVE_MAX + 1];
	}Slave;
};

/*
 * Functions
 * ~~~~~~~~~
 */
/** Get usb. */
pBsp_board_usb_s	bsp_get_board_usb(	void);

/* Reset Usb */
int bsp_reset_gpio_usb(				void);

#endif

#endif

// vim:ts=5:
