/*
 * ============================================================================
 *
 * Copyright : (c) 2009 SAGEM SA - Site Velizy - URD2
 *
 * The information and source code contained herein is the exclusive
 * property of SAGEM and may not be disclosed, examined, or
 * reproduced in whole or in part without explicit written authorization
 * of the company.
 *
 * ============================================================================
 */

#ifndef __BSP_VOICE_H__
#define __BSP_VOICE_H__

/**
 * \file bsp_voice.h Bsp description for manage Voice.
 *
 * This file allow to describe Bsp Voice Public.
*/

#ifdef __KERNEL__

/*
 * Defines
 * ~~~~~~~~
 */

/** \name Voice.
 */
/*@{*/
/** FXS MAX. */
#define	BSP_VOICE_FXS_MAX			2
/** FXO MAX. */
#define	BSP_VOICE_FXO_MAX			1
/*@}*/

/*
 * Typedefs
 * ~~~~~~~~
 */

/** \name bsp_board_voice struct Typedefs.
 */
/*@{*/
/** \link bsp_board_voice_str bsp_board_voice struct \endlink typedef. */
typedef struct bsp_board_voice_str			bsp_board_voice_s;
/** \link bsp_board_voice_str bsp_board_voice struct \endlink pointer typedef. */
typedef struct bsp_board_voice_str			*pBsp_board_voice_s;
/*@}*/

/*
 * Structs
 * ~~~~~~~
 */

/** Bsp_borad_voice_str.
 *
 * 	This struct manage board voice Information.
 */
struct bsp_board_voice_str {
	/** Struct manage Fxs. */
	struct {
		/** Nb. */
		int					nb;

		/** All Name. */
		bsp_gpio_name_e		all[BSP_VOICE_FXS_MAX + 1];
	}Fxs;

	/** Struct manage Fxs. */
	struct {
		/** Nb. */
		int 				nb;
	
		/** All Name. */
		bsp_gpio_name_e		all[BSP_VOICE_FXO_MAX + 1];
	}Fxo;
};

/*
 * Functions
 * ~~~~~~~~~
 */
/** Get Voice. */
pBsp_board_voice_s	bsp_get_board_voice(	void);

/* Reset Voice */
int bsp_reset_gpio_voice(				void);

#endif

#endif

// vim:ts=5:
