#ifndef _MC_ACCEL_H
#define _MC_ACCEL_H

#include <linux/netdevice.h>
#include <linux/skbuff.h>

/* Attempt accelerated delivery of a packet.
 * @return 0      delivered (mc_accel took ownership of skb)
 *         ESRCH  not delivered (to be processed by slow path like usual)
 *                or delivered but still needs to be passed to the slow path
 *         EINVAL malformed packet (too short, not Ethernet)
 *         ENOMEM delivered to some destinations but not enough memory for all
 */
int mc_accel(struct sk_buff *skb);

extern int (*mc_accel_hook)(struct sk_buff *skb);

#endif /* _MC_ACCEL_H */
