#
# Component.mk file for CURL
# $(SAH_MIDDLEWARE_COMPONENT_DIR)
#
# Currently, the RELEASEDIR is the saw mw root_fs dir. This should become the "release" dir
#
include $(STAGINGDIR)/components.config

CFLAGS += -I$(STAGINGDIR)/include/zlib

curl.pc: curl.pc.m4 $(STAGINGDIR)/components.config
	cat $(STAGINGDIR)/components.config.m4 $< | m4 > $@

all: Makefile
	@echo "building curl"
	make

Makefile: 
	@echo "Target: " $(CONFIG_BUILD_HARDWARE)
ifeq ($(CONFIG_BUILD_HARDWARE),"x86-linux")
	LIBS="-ldl" ./configure --with-ssl=$(STAGINGDIR)
else
	CFLAGS=$(CFLAGS) LIBS="-ldl" ./configure --host=mips-linux-uclibc --with-ssl=$(STAGINGDIR) --enable-ftp --with-zlib=$(STAGINGDIR)/lib --enable-ipv6
endif

clean:
	@echo "cleaning curl"
	if [ -f Makefile ]; then make distclean; fi

install: all curl.pc
	@echo "installing curl to: " $(STAGINGDIR)
	$(INSTALL) -d $(STAGINGDIR)/include/curl
	$(INSTALL) -m 644 include/curl/*.h $(STAGINGDIR)/include/curl
	$(INSTALL) -d $(STAGINGDIR)/lib
	$(INSTALL) -m 644 lib/.libs/libcurl.so.4.1.1 $(STAGINGDIR)/lib
	cd $(STAGINGDIR)/lib; ln -sf libcurl.so.4.1.1 libcurl.so.4.1
	cd $(STAGINGDIR)/lib; ln -sf libcurl.so.4.1.1 libcurl.so.4
	cd $(STAGINGDIR)/lib; ln -sf libcurl.so.4.1.1 libcurl.so	
	$(INSTALL) -D -m 0644 curl.pc $(PKG_CONFIG_LIBDIR)/curl.pc
ifeq ($(CONFIG_SAH_LIB_CURL_INSTALL_EXECUTABLE),y)
	$(INSTALL) -d $(STAGINGDIR)/usr/bin
	$(INSTALL) -m 755 src/.libs/curl $(STAGINGDIR)/usr/bin
endif

release:
	@echo "releasing curl in: " $(ROOT_FS_DIR)
	$(INSTALL) -d $(ROOT_FS_DIR)/lib
	cp -dp $(STAGINGDIR)/lib/libcurl.so* $(ROOT_FS_DIR)/lib
	$(STRIP) $(ROOT_FS_DIR)/lib/libcurl.so.4.1.1
ifeq ($(CONFIG_SAH_LIB_CURL_INSTALL_EXECUTABLE),y)
	$(INSTALL) -d $(ROOT_FS_DIR)/usr/bin
	$(INSTALL) -m 755 $(STAGINGDIR)/usr/bin/curl $(ROOT_FS_DIR)/usr/bin
	$(STRIP) $(ROOT_FS_DIR)/usr/bin/curl
endif

.PHONY: all clean install release

