VERSION=0.14
PROGRAM=libdaemon.so.$(VERSION)

ifeq ($(notdir $(CC)),gcc)
	CFG:=--host=i386-linux --enable-shared --with-gnu-ld
else
	CFG:=--build=i386-linux --host=mips-linux
endif

all: Makefile libdaemon/libdaemon.la

Makefile:
	./configure $(CFG) --prefix=/ --disable-lynx --disable-examples ac_cv_func_setpgrp_void=y

libdaemon/libdaemon.la:
	make

clean:
	-make clean

install:
	@echo " ##   Installing $(PROGRAM)"
	make DESTDIR=$(STAGINGDIR) install

release:
	@echo " ##   Releasing $(PROGRAM)"
	$(INSTALL) -d $(ROOT_FS_DIR)/lib
	$(INSTALL) -m 755 ${STAGINGDIR}/lib/libdaemon.so.0.5.0 $(ROOT_FS_DIR)/lib/
	${STRIP} $(ROOT_FS_DIR)/lib/libdaemon.so.0.5.0
	cd $(ROOT_FS_DIR)/lib ; ln -sf libdaemon.so.0.5.0 libdaemon.so.0
	cd $(ROOT_FS_DIR)/lib ; ln -sf libdaemon.so.0.5.0 libdaemon.so

doc:

.PHONY: all install release clean doc Makefile
