ifeq ($(notdir $(CC)),gcc)
	CONFIGURE_LIBRARY_PATH=$(STAGINGDIR)/lib
  HOSTMACHINE=i386-linux
else
	CONFIGURE_LIBRARY_PATH=
  HOSTMACHINE=mips-linux
endif

CFLAGS=-Os -I$(STAGINGDIR)/include -DUSE_PCB_LOOP=y -DDEBUG=y $(shell pkg-config --cflags sahtrace pcb)
LDFLAGS=-L$(STAGINGDIR)/lib $(shell pkg-config --libs sahtrace pcb)

all: libdnsres.so

stamp-h1: $(STAGINGDIR)/components.config
	LD_LIBRARY_PATH=$(CONFIGURE_LIBRARY_PATH) ./configure 	--build=i386-linux \
			--host=$(HOSTMACHINE) \
			--without-libevent  \
			--with-pic \
			CFLAGS="$(CFLAGS)" \
			LDFLAGS="$(LDFLAGS)"

libdnsres.so: stamp-h1
	CFLAGS=-I$(STAGINGDIR)/include LDFLAGS=-I$(STAGINGDIR)/lib make all

clean:
	test ! -e Makefile || make distclean

install:
	echo "Install libdnsres to: $(STAGINGDIR)"
	$(INSTALL) -d $(STAGINGDIR)/include/dnsres
	$(INSTALL) -m 644 pcb_dnsres.h $(STAGINGDIR)/include/dnsres
	$(INSTALL) -m 644 dnsres.h $(STAGINGDIR)/include/dnsres
	$(INSTALL) -d $(STAGINGDIR)/lib
	$(INSTALL) -m 755 .libs/libdnsres.so.0.0.1 $(STAGINGDIR)/lib/libdnsres.so
	ln -sf libdnsres.so $(STAGINGDIR)/lib/libdnsres.so.0
	$(INSTALL) -D -m 0644 dnsres.pc $(PKG_CONFIG_LIBDIR)/dnsres.pc

release:
	echo "Release libdnsres to: $(ROOT_FS_DIR)"
	$(INSTALL) -d 0755 $(ROOT_FS_DIR)/lib
	$(INSTALL) -m 0755 $(STAGINGDIR)/lib/libdnsres.so $(ROOT_FS_DIR)/lib/libdnsres.so
	$(STRIP) $(ROOT_FS_DIR)/lib/libdnsres.so
	ln -sf libdnsres.so $(ROOT_FS_DIR)/lib/libdnsres.so.0

getaddrinfo:
	$(CC) $(CFLAGS) -Wall -c -o test/getaddrinfo_test.o test/getaddrinfo_test.c
	$(CC) $(LDFLAGS) -ldnsres  test/getaddrinfo_test.o -o .libs/getaddrinfo_test

gethostbyaddr:
	$(CC) $(CFLAGS) -Wall -c -o test/gethostbyaddr_test.o test/gethostbyaddr_test.c
	$(CC) $(LDFLAGS)  -ldnsres test/gethostbyaddr_test.o -o .libs/gethostbyaddr_test

getaddrinfob:
	$(CC) $(CFLAGS) -Wall -c -o test/getaddrinfo_b_test.o test/getaddrinfo_b_test.c
	$(CC) $(LDFLAGS) -ldnsres  test/getaddrinfo_b_test.o -o .libs/getaddrinfo_b_test

gethostbyaddrb:
	$(CC) $(CFLAGS) -Wall -c -o test/gethostbyaddr_b_test.o test/gethostbyaddr_b_test.c
	$(CC) $(LDFLAGS)  -ldnsres test/gethostbyaddr_b_test.o -o .libs/gethostbyaddr_b_test


test: getaddrinfo gethostbyaddr getaddrinfob gethostbyaddrb

