#ifndef _DNSRESPCB_H_
#define _DNSRESPCB_H_

#include "dnsres.h"


#define DEFAULT_TIMEOUT 8

typedef struct _pcb_dnsres pcb_dnsres_t;

#define PCB_DNSRES_USE_TCP                   0x00000001
#define PCB_DNSRES_STOP_RETRY_ON_NXDOMAIN    0x00000002
#define PCB_DNSRES_LAST_RETRY_ALWAYS_TIMEOUT 0x00000004

pcb_dnsres_t *pcb_dnsres_gethostbyaddr(connection_info_t *con,
                                     unsigned int res_options,
                                     const char *retry_policy,
                                     const void *addr,
                                     int len,
                                     int af,
                                     void (*cb)(struct dnsres_hostent *hp, int error, void *arg),
                                     void *arg);

pcb_dnsres_t *pcb_dnsres_getaddrinfo(connection_info_t *con,
                                   unsigned int res_options,
                                   const char *retry_policy,
                                   const char *hostname,
                                   const char *servname,
                                   struct addrinfo *hints,
                                   void (*cb)(struct addrinfo *ai, int error, void *arg),
                                   void *arg);

pcb_dnsres_t *pcb_dnsres_getaddrinfo_ext(connection_info_t *con,
                                   unsigned int res_options,
                                   const char *retry_policy,
                                   const char *hostname,
                                   const char *servname,
                                   struct addrinfo *hints,
                                   void (*cb)(pcb_dnsres_t *request, struct addrinfo_ext *ai, int error, void *arg),
                                   void *arg);


void pcb_dnsres_cancelRequest(pcb_dnsres_t *request);


int pcb_dnsres_gethostbyaddr_b(unsigned int res_options,
                                     const char *retry_policy,
                                     const void *addr,
                                     int len,
                                     int af,
                                     struct dnsres_hostent **he);

int pcb_dnsres_getaddrinfo_b(unsigned int res_options,
                                   const char *retry_policy,
                                   const char *hostname,
                                   const char *servname,
                                   struct addrinfo *hints,
                                   struct addrinfo **res);

void pcb_dnsres_gethostbyaddr_b_free_hostent(struct dnsres_hostent *he);
void pcb_dnsres_free_addrinfo_ext(struct addrinfo_ext *ai);


#endif





