
.PHONY=all clean install release build

ifeq ($(notdir $(CC)),gcc)
  LIBEXIF_FULL_CONFIGURATION:=$(LIBEXIF_FULL_CONFIGURATION) --host=i386-linux --enable-shared --with-gnu-ld
  STRIP:=strip
else
  LIBEXIF_FULL_CONFIGURATION:=$(LIBEXIF_FULL_CONFIGURATION) --host=mips-linux-uclibc
endif

all:  Makefile
	make
	cp -f libexif/.libs/libexif.a .

Makefile:
	./configure $(LIBEXIF_FULL_CONFIGURATION)
	

clean:
	@echo "Cleaning EXIF"
	@if [ -e Makefile ]; then make distclean; fi
	@rm -f libexif.a

install:
	@echo "Install EXIF lib to: $(STAGINGDIR)"
	$(INSTALL) -d $(STAGINGDIR)/include/libexif
	$(INSTALL) ./libexif/*.h $(STAGINGDIR)/include/libexif
	$(INSTALL) -d $(STAGINGDIR)/lib
	$(INSTALL) -m 644 ./libexif/.libs/libexif.so $(STAGINGDIR)/lib/libexif.so.12
	(cd $(STAGINGDIR)/lib; ln -sf libexif.so.12 libexif.so)

release:
	@echo "Release EXIF lib to $(ROOT_FS_DIR)"
	$(INSTALL) -d $(ROOT_FS_DIR)/lib
	cp -dpf $(STAGINGDIR)/lib/libexif.so* $(ROOT_FS_DIR)/lib
	$(STRIP) $(ROOT_FS_DIR)/lib/libexif.so.12

.PHONY: all clean install release
