all: Makefile
	@echo "-------------------------------------------------------------"
	@echo "- building libexpat.so"
	@echo "-------------------------------------------------------------"
	make all

Makefile:
	./configure --prefix=/usr --host=mips-linux-uclibc --build=i386-linux --enable-shared --disable-static --with-gnu-ld

clean:
	@echo "-------------------------------------------------------------"
	@echo "- cleaning libexpat.so"
	@echo "-------------------------------------------------------------"
	-make clean
	-make distclean

install:
	@echo "-------------------------------------------------------------"
	@echo "- installing libexpat.so headers to: " $(STAGINGDIR)
	@echo "-------------------------------------------------------------"
	$(INSTALL) -d $(STAGINGDIR)/include/expat
	$(INSTALL) ./lib/expat_external.h $(STAGINGDIR)/include/expat
	$(INSTALL) ./lib/expat.h $(STAGINGDIR)/include/expat
	$(INSTALL) ./lib/xmlrole.h $(STAGINGDIR)/include/expat
	$(INSTALL) ./lib/xmltok.h $(STAGINGDIR)/include/expat
	@echo "-------------------------------------------------------------"
	@echo "- installing libexpat.so to: " $(STAGINGDIR)
	@echo "-------------------------------------------------------------"
	$(INSTALL) -d $(STAGINGDIR)/lib
	$(INSTALL) -m 755 ./.libs/libexpat.so.1.5.2 $(STAGINGDIR)/lib/
	ln -sf libexpat.so.1.5.2 $(STAGINGDIR)/lib/libexpat.so.1
	ln -sf libexpat.so.1 $(STAGINGDIR)/lib/libexpat.so

release:
	@echo "-------------------------------------------------------------"
	@echo "- make a libexpat.so release in: " $(RELEASEDIR)
	@echo "-------------------------------------------------------------"
	$(INSTALL) -d $(RELEASEDIR)/lib
	cp -dp $(STAGINGDIR)/lib/libexpat.so* $(RELEASEDIR)/lib
	$(STRIP) $(RELEASEDIR)/lib/libexpat.so

doc: 

.PHONY: clean all install release doc
