/*
 * Copyright (c) 2011 SoftAtHome
 *
 * The information and source code contained herein is the exclusive
 * property of SoftAtHome and may not be disclosed, examined, or
 * reproduced in whole or in part without explicit written authorization
 * of the copyright owner.
 *
 * Author : Dries De Winter (dries.dewinter@softathome.com)
 *
 */
#include <stdio.h>
#include <pthread.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/select.h>

#include "libexample.h"

static pthread_t thread1, thread2;
static pthread_mutex_t mutex1 = PTHREAD_MUTEX_INITIALIZER, mutex2 = PTHREAD_MUTEX_INITIALIZER;

static void h() {
	pthread_mutex_lock(&mutex1);
}

static void g() {
	h();
}

static void f() {
	g();
}

static void *run1(void *arg) {
	while (1) {
		f();
		pthread_mutex_lock(&mutex2);
		pthread_mutex_unlock(&mutex1);
		pthread_mutex_unlock(&mutex2);
	}
	return arg;
}

static void *run2(void *arg) {
	while (1) {
		pthread_mutex_lock(&mutex2);
		f();
		pthread_mutex_unlock(&mutex1);
		pthread_mutex_unlock(&mutex2);
	}
	return arg;
}

int main(void) {
	FILE *pidfile = fopen("example11.pid", "w");
	fprintf(pidfile, "%d\n", getpid());
	fclose(pidfile);
	pthread_create(&thread1, NULL, run1, NULL);
	pthread_create(&thread2, NULL, run2, NULL);
	while (1)
		select(0, NULL, NULL, NULL, NULL);
	return 0;
}
