/*
 * Copyright (c) 2011 SoftAtHome
 *
 * The information and source code contained herein is the exclusive
 * property of SoftAtHome and may not be disclosed, examined, or
 * reproduced in whole or in part without explicit written authorization
 * of the copyright owner.
 *
 * Author : Dries De Winter (dries.dewinter@softathome.com)
 *
 */
#include <stdlib.h>
#include <dlfcn.h>
#include <unistd.h>
#include <signal.h>
#include <sys/select.h>
#include <stdio.h>

static int done = 0;

static void h() {
	int i;
	void *ptr;
	for (i=0; i<20; i++)
		ptr = malloc(555);
	free(ptr);
	for (i=0; i<20; i++)
		ptr = calloc(1, 100);
	free(ptr);
}

static void g() {
	h();
}

static void f() {
	g();
}

static void signalhandler(int signum) {
	done = signum;
}

int main(void) {
	void *handle = dlopen("libexample.so", RTLD_NOW);
	void (*libexample_f)(void (*func)(void)) = dlsym(handle, "libexample_f");
	libexample_f(f);
	signal(SIGTERM, signalhandler);
	signal(SIGINT, signalhandler);
	printf("daemonize\n");
	daemon(1, 1);
	while (!done)
		select(0, NULL, NULL, NULL, NULL);
	dlclose(handle);
	return 0;
}
