/*
 * Copyright (c) 2011 SoftAtHome
 *
 * The information and source code contained herein is the exclusive
 * property of SoftAtHome and may not be disclosed, examined, or
 * reproduced in whole or in part without explicit written authorization
 * of the copyright owner.
 *
 * Author : Dries De Winter (dries.dewinter@softathome.com)
 *
 */
#define _GNU_SOURCE
#include <stdlib.h>
#include <unistd.h>
#include <signal.h>
#include <sys/select.h>
#include <stdio.h>

#include "libexample.h"

static int done = 0;

static char *numbers[1000];

static void h() {
	int i;
	for (i=0; i<1000; i++)
		if (asprintf(&numbers[i], "%d", i) == -1)
			fprintf(stderr, "asprintf failed\n");
}

static void cleanup() {
	int i;
	for (i=0; i<1000; i++)
		free(numbers[i]);
}

static void g() {
	h();
}

static void f() {
	g();
}

static void signalhandler(int signum) {
	done = signum;
}

int main(void) {
	libexample_f(f);
	printf("daemonize\n");
	daemon(1, 1);
	signal(SIGTERM, signalhandler);
	signal(SIGINT, signalhandler);
	while (!done)
		select(0, NULL, NULL, NULL, NULL);
	cleanup();
	return 0;
}
