/*
 * Copyright (c) 2011 SoftAtHome
 *
 * The information and source code contained herein is the exclusive
 * property of SoftAtHome and may not be disclosed, examined, or
 * reproduced in whole or in part without explicit written authorization
 * of the copyright owner.
 *
 * Author : Dries De Winter (dries.dewinter@softathome.com)
 *
 */
#ifndef __COMMON_H__
#define __COMMON_H__

#if defined(WITHTHREADS) && defined(NOTHREADS)
#error "Define either WITHTHREADS or NOTHREADS, but not both!"
#elif !defined(WITHTHREADS) && !defined(NOTHREADS)
#error "Define either WITHTHREADS or NOTHREADS!"
#endif

#include <stdio.h>
#include <stdarg.h>
#include <unistd.h>

#define REGULARBTSIZE 16
#define HEAPBTSIZE 10
#define BUFSIZE 512
#define CAPTIONSIZE 28
#define STATICMAPSIZE 48
#define STACKMAPSIZE 100

void mafia_fdprintf(int fd, const char *fmt, ...);

 // needed for privileged usage of backtrace.c by heap.c

typedef struct map {
	void *start;
	void *end;
	unsigned long offset;
	int pathpos;
	int file;
} map_t;
int backtrace_prologue(map_t **maps, int *mapssize, int *usestaticmaps);
void backtrace_dumppriv(void *const *buffer, int size, int fd, int attributes, map_t *maps, int mapssize, int usestaticmaps, int mapsfd);
void backtrace_epilogue(map_t *maps, int mapssize, int usestaticmaps, int mapsfd);

#endif
