TOOLCHAINPATH=$(dir $(CROSS_COMPILE))

all: lib/libncurses.a

lib/libncurses.a: Makefile
	export PATH=$(TOOLCHAINPATH):$$PATH; \
	make

Makefile: configure
	export PATH=$(TOOLCHAINPATH):$$PATH; \
	./configure --host=mips-linux-uclibc --without-cxx --without-cxx-binding --without-ada \
	--without-progs --without-gpm --disable-big-core --disable-termcap \
	--disable-home-terminfo --disable-largefile --without-manpages

install:
	export PATH=$(TOOLCHAINPATH):$$PATH; \
	RANLIB=$(CROSS_COMPILE)ranlib; make install DESTDIR=$(STAGINGDIR)
	$(INSTALL) -d $(STAGINGDIR)/usr/share/terminfo
	$(INSTALL) -d $(STAGINGDIR)/usr/share/terminfo/l
	$(INSTALL) terminfo/linux $(STAGINGDIR)/usr/share/terminfo/l/
	$(INSTALL) -d $(STAGINGDIR)/usr/share/terminfo/v
	$(INSTALL) terminfo/vt102 $(STAGINGDIR)/usr/share/terminfo/v/

release:
	$(INSTALL) -d $(ROOT_FS_DIR)/usr/share/terminfo
	$(INSTALL) -d $(ROOT_FS_DIR)/usr/share/terminfo/l
	$(INSTALL) terminfo/linux $(ROOT_FS_DIR)/usr/share/terminfo/l/
	$(INSTALL) -d $(ROOT_FS_DIR)/usr/share/terminfo/v
	$(INSTALL) terminfo/vt102 $(ROOT_FS_DIR)/usr/share/terminfo/v/

clean:
	[ -e Makefile ] && make clean
	rm -f Makefile */Makefile
	rm -f conf*.file config.log config.status
	rm -f edit_man.sed edit_man.sh headers.sh
	rm -f include/MKterm.h.awk include/curses.head include/ncurses_cfg.h include/termcap.h include/unctrl.h
	rm -f misc/ncurses-config misc/run_tic.sh

doc:

.PHONY: all install release clean doc
