/**
@file
@brief
Header file that includes all core header files
*/

#include <pcb/utils.h>

/**
@defgroup pcb_core Datamodel
@{
@brief
Data model management functions

@details
The data model part is a collection of functions and definitions that implement the basic functionalit of PCB data model
management.\n
This includes:
  - @ref pcb_core_dm_management 
  - @ref pcb_core_object
  - @ref pcb_core_parameter
  - @ref pcb_core_function
  - @ref pcb_core_notification
  - @ref pcb_core_requests
  - @ref pcb_core_replies
  - @ref pcb_core_serialization
  - @ref pcb_core_validator
@}
*/

#include <pcb/core/datamodel.h>
#include <pcb/core/notification.h>
#include <pcb/core/pcb_main.h>
#include <pcb/core/reply.h>
#include <pcb/core/requesthandlers.h>
#include <pcb/core/validator.h>
#include <pcb/core/mapping.h>
#include <pcb/core/acl.h>
