/****************************************************************************
**
** Copyright (C) 2011 SoftAtHome. All rights reserved.
**
** SoftAtHome reserves all rights not expressly granted herein.
**
** - DISCLAIMER OF WARRANTY -
**
** THIS FILE IS PROVIDED "AS IS" WITHOUT WARRANTY OF ANY KIND, EITHER
** EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED TO, THE IMPLIED
** WARRANTIES OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR
** PURPOSE.
**
** THE ENTIRE RISK AS TO THE QUALITY AND PERFORMANCE OF THE SOURCE
** CODE IS WITH YOU. SHOULD THE SOURCE CODE PROVE DEFECTIVE, YOU
** ASSUME THE COST OF ALL NECESSARY SERVICING, REPAIR OR CORRECTION.
**
** - LIMITATION OF LIABILITY -
**
** IN NO EVENT UNLESS REQUIRED BY APPLICABLE LAW OR AGREED TO IN
** WRITING WILL ANY COPYRIGHT HOLDER, OR ANY OTHER PARTY WHO MODIFIES
** AND/OR DISTRIBUTES THE SOURCE CODE, BE LIABLE TO YOU FOR DAMAGES,
** INCLUDING ANY GENERAL, SPECIAL, INCIDENTAL OR CONSEQUENTIAL DAMAGES
** ARISING OUT OF THE USE OR INABILITY TO USE THE SOURCE CODE
** (INCLUDING BUT NOT LIMITED TO LOSS OF DATA OR DATA BEING RENDERED
** INACCURATE OR LOSSES SUSTAINED BY YOU OR THIRD PARTIES OR A FAILURE
** OF THE SOURCE CODE TO OPERATE WITH ANY OTHER PROGRAM), EVEN IF SUCH
** HOLDER OR OTHER PARTY HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH
** DAMAGES.
**
****************************************************************************/

#if !defined(PCB_CORE_TYPES_H)
#define PCB_CORE_TYPES_H

#ifdef __cplusplus
extern "C"
{
#endif

#include <pcb/utils/linked_list.h>

typedef struct _pcb pcb_t;
typedef struct _request_handlers request_handlers_t;
typedef struct _notification notification_t;
typedef struct _object object_t;
typedef struct _parameter parameter_t;
typedef struct _datamodel datamodel_t;
typedef struct _object_validator object_validator_t;
typedef struct _request request_t;
typedef llist_t object_list_t;
typedef llist_t request_list_t;
typedef llist_iterator_t parameter_iterator_t;
typedef struct _reply reply_t;
typedef struct _reply_item reply_item_t;
typedef struct _parameter_validator parameter_validator_t;
typedef struct _notification_parameter notification_parameter_t;
typedef llist_t buffer_list_t;
typedef struct _function function_t;
typedef struct _function_argument function_argument_t;
typedef struct _param_value argument_value_t;
typedef struct _function_call function_call_t;
typedef struct _object_destination object_destination_t;
typedef struct _destination_parameter destination_parameter_t;
typedef struct _destination_parameter destination_function_t;
typedef struct _mapping_rule mapping_rule_t;
typedef llist_t argument_value_list_t;

#ifdef __cplusplus
}
#endif

#endif

