# include components.config
STAGINGDIR = $$(STAGINGDIR)

!isEmpty(STAGINGDIR):include ($$(STAGINGDIR)/components.config)
else:error(STAGINGDIR environment variable not defined)

TARGET = pcb
TEMPLATE = lib
CONFIG -= qt
CONFIG += shared \
          dll \
          debug

SOURCES = $$system(ls src/common/*.c) \
          $$system(ls src/utils/*.c) \
          $$system(ls src/core/*.c)

PUBLIC_HEADERS = $$system(ls include/pcb/common/*.h) \
                 $$system(ls include/pcb/utils/*.h) \
                 $$system(ls include/pcb/core/*.h)

PRIVATE_HEADERS = $$system(ls src/core/*.h)

contains(CONFIG_SAH_TRACES_ENABLED,y):DEFINES += SAHTRACES_ENABLED
contains(CONFIG_PCB_DUMP_ENABLED,y):DEFINES += PCB_DUMP_ENABLED

# remove this line to enable debugging functions
DEFINES += NDEBUG

INCLUDEPATH += include \
               $$(STAGINGDIR)/include
DESTDIR = .
HEADERS = $$PUBLIC_HEADERS \
          $$PRIVATE_HEADERS

LIBS += -L$$(STAGINGDIR)/lib \
        -lsahtrace \
        -ldl \
        -lcrypt

OTHER_FILES += ../../plugins/pcb_serialize_tpl/src/packages.txt
