#include <pcb/core/acl.h>

#include "core_priv.h"

ACL_t *acl_first(const llist_t *list) {
    if (!list) {
        return NULL;
    }

    llist_iterator_t *it = llist_first(list);
    ACL_t *rv = NULL;
    if (it) {
        rv = llist_item_data(it,ACL_t,it);
    }

    return rv;
}

ACL_t *acl_next(ACL_t *acl) {
    if (!acl) {
        return NULL;
    }

    llist_iterator_t *it = llist_iterator_next(&acl->it);
    ACL_t *rv = NULL;
    if (it) {
        rv = llist_item_data(it,ACL_t,it);
    }

    return rv;
}

uint32_t acl_id(ACL_t *acl) {
    if (!acl) {
        return UINT32_MAX;
    }

    return acl->id;
}

uint16_t acl_flags(ACL_t *acl) {
    if (!acl) {
        return 0;
    }

    return acl->acl_flags;
}
