#!/usr/bin/env bash

DIRECTORY=$(cd `dirname $0` && pwd)
cd $DIRECTORY

. ../shell_unit.sh
. ../testsources.sh

# testplan local_standalone
testplan remote
# testplan local_standalone
# testplan remote_standalone

pcb_utils_r_testplan() {
    export SAHTRACE=200
    run_c_tests ./unittests/test_circbuf.so "Test the circular buffer implementation" 
    run_c_tests ./unittests/test_connection.so "Test connection and peer functionality"
    run_c_tests ./unittests/test_linked_list.so "Test the linked list implementation"
    run_c_tests ./unittests/test_string.so "Test the string implementation"
    run_c_tests ./unittests/test_tree.so "Test the hierarchical tree implementation"
    run_c_tests ./unittests/test_variant.so "Test variant implementation"

    run_test_done
}

if [[ $0 == $BASH_SOURCE ]]; then
    run_testplan pcb_utils_r_testplan
fi    

