#!/bin/bash

DIRECTORY=$(cd `dirname $0` && pwd)
cd $DIRECTORY

. ../shell_unit.sh
. ../testsources.sh

testplan local_standalone
# testplan remote
# testplan local_standalone
# testplan remote_standalone

testplan_setup() {
    mv $STAGINGDIR/lib/libcrypto.so $STAGINGDIR/lib/libcrypto.backup
    mv $STAGINGDIR/lib/libssl.so $STAGINGDIR/lib/libssl.backup
}

testplan_teardown() {
    mv $STAGINGDIR/lib/libcrypto.backup $STAGINGDIR/lib/libcrypto.so
    mv $STAGINGDIR/lib/libssl.backup $STAGINGDIR/lib/libssl.so
}

pcb_utils_testplan() {
    export SAHTRACE=200
    run_c_tests ./unittests/test_circbuf.so "Test the circular buffer implementation" 
    run_c_tests ./unittests/test_connection.so "Test connection and peer functionality"
    run_c_tests ./unittests/test_linked_list.so "Test the linked list implementation"
    run_c_tests ./unittests/test_string.so "Test the string implementation"
    run_c_tests ./unittests/test_tree.so "Test the hierarchical tree implementation"
    run_c_tests ./unittests/test_variant.so "Test variant implementation"

    run_test_done
}

if [[ $0 == $BASH_SOURCE ]]; then
    run_testplan pcb_utils_testplan
fi    

