#Makefile for Component lib/sqlite
SRC=sqlite-3.6.16

SQLITE_FLAGS=\
-DSQLITE_OMIT_AUTHORIZATION \
-DSQLITE_OMIT_AUTOVACUUM \
-DSQLITE_OMIT_EXPLAIN \
-DSQLITE_OMIT_FLOATING_POINT \
-DSQLITE_OMIT_LOAD_EXTENSION \
-DSQLITE_OMIT_TCL_VARIABLE \
-DSQLITE_OMIT_UTF16

# option needed for dlna dms
SQLITE_FLAGS += -DSQLITE_ENABLE_COLUMN_METADATA

CFLAGS += -Os
CFLAGS += $(SQLITE_FLAGS)
CFLAGS += -g

OBJS= $(SRCS:.c=.o)

ifneq ($(notdir $(CC)),gcc)
  HOST=--host=mips-linux-uclibc --build=i686
endif

SQLLITE_LIBNAME=libsqlite3
SONAME=libsqlite3.so.0.8.6
LINKS=libsqlite3.so.0 libsqlite3.so libsqlite.so

all: $(SRC)/Makefile
	make -C $(SRC)

$(SRC)/Makefile:
	cd $(SRC) && CFLAGS="$(CFLAGS)" ./configure $(HOST) --enable-shared --enable-static --enable-threadsafe \
				--enable-cross-thread-connections --disable-tcl --disable-readline --with-pic \
				--disable-largefile --prefix=

clean:
	make -C $(SRC) distclean

install:
	@echo "Installing to: " $(STAGINGDIR)
	make -C $(SRC) DESTDIR=$(STAGINGDIR) install
	cd $(STAGINGDIR)/lib && ln -fs $(SONAME) libsqlite.so
	# remove unneeded static library to avoid other application linking against it
	rm -f $(STAGINGDIR)/lib/libsqlite3.la
	#ln -sf $(SQLLITE_LIBNAME).a $(STAGINGDIR)/lib/$(SQLLITE_LIBNAME)_pic.a

release:
	@echo "make a release in: " $(ROOT_FS_DIR)
	$(INSTALL) -d $(ROOT_FS_DIR)/lib
	$(INSTALL) -m 755 $(STAGINGDIR)/lib/$(SONAME) $(ROOT_FS_DIR)/lib
	$(STRIP) $(ROOT_FS_DIR)/lib/$(SONAME)
	cd $(ROOT_FS_DIR)/lib && (for i in $(LINKS); do ln -fs $(SONAME) $$i; done)
.PHONY: all clean install release
