CFLAGS += -Os
CFLAGS += -g

OBJS= $(SRCS:.c=.o)

ifneq ($(notdir $(CC)),gcc)
  HOST=--host=mips-linux
endif

SONAME=libusb-0.1.so.4.4.4
LINKS=libusb-0.1.so.4 libusb.so

all: Makefile
	make

Makefile:
	./configure $(HOST) --enable-shared --with-pic --disable-build-docs --without-pkgconfig --prefix= \
	CFLAGS="$(CFLAGS)" STRIP="$(STRIP)" CC="$(CC)" CXX="$(CXX)"

clean:
	-make clean
	rm -rf .deps .libs tests/.deps
	rm -f Makefile config.h config.log config.status */Makefile
	rm -f *.lo *.loT *.la *.pc
	rm -f libtool libusb-config stamp-* usb.h
	rm -rf autom4te.cache

install:
	@echo "Installing to: " $(STAGINGDIR)
	make DESTDIR=$(STAGINGDIR) install

release:
	@echo "make a release in: " $(ROOT_FS_DIR)
	$(INSTALL) -d $(ROOT_FS_DIR)/lib
	$(INSTALL) -m 644 $(STAGINGDIR)/lib/$(SONAME) $(ROOT_FS_DIR)/lib/
	$(STRIP) $(ROOT_FS_DIR)/lib/$(SONAME)
	cd $(ROOT_FS_DIR)/lib && (for i in $(LINKS); do ln -fs $(SONAME) $$i; done)

.PHONY: all clean install release
