PROGRAM=dnsmasq
SRC=src
VPATH=$(SRC)

# CFLAGS = -Wall -W -O2
CFLAGS = -Wall -W -g
CFLAGS += -DHAVE_IPV4 -DHAVE_IPV6 -DHAVE_FALLBACK_MECHANISM

OBJS = cache.o rfc1035.o util.o option.o forward.o network.o \
       dnsmasq.o dhcp.o lease.o rfc2131.o netlink.o dbus.o bpf.o \
       helper.o tftp.o log.o

all : $(PROGRAM) Component.mk

clean :
	rm -f *.o ${PROGRAM}
	rm -f core

install : all
	$(INSTALL) -d $(STAGINGDIR)/sbin
	$(INSTALL) -m 755 $(PROGRAM) $(STAGINGDIR)/sbin
	$(INSTALL) -d $(STAGINGDIR)/etc_ro_fs/init.d
	$(INSTALL) -m 755 scripts/dnsmasq $(STAGINGDIR)/etc_ro_fs/init.d/dnsmasq

release : all
	$(INSTALL) -d $(ROOT_FS_DIR)/sbin
	$(INSTALL) -m 755 $(PROGRAM) $(ROOT_FS_DIR)/sbin
	$(STRIP) $(ROOT_FS_DIR)/sbin/${PROGRAM}
	$(INSTALL) -d $(ROOT_FS_DIR)/etc_ro_fs/init.d
	$(INSTALL) -m 755 scripts/dnsmasq $(ROOT_FS_DIR)/etc_ro_fs/init.d/dnsmasq

doc :

.c.o:
	$(CC) $(CFLAGS) -c $<

${PROGRAM} : $(OBJS)
	$(CC) $(LDFLAGS) -o $@ $(OBJS)

.PHONY : all clean install release doc
