-include $(STAGINGDIR)/components.config

DHCLIENT=client/dhclient
DHCPD=server/dhcpd

ifeq ($(notdir $(CC)),gcc)
	CFG:=--host=i386-linux --enable-shared --with-gnu-ld
else
	CFG:=--build=i386-linux --host=mips-linux --disable-failover --disable-execute
endif

EXTRA_CFLAGS = -ffunction-sections -fdata-sections
EXTRA_LDFLAGS = -Wl,--gc-sections

export EXTRA_CFLAGS EXTRA_LDFLAGS

HAVE_DEV_RANDOM=y

all: Makefile
	make -C bind
	make

Makefile:
	ac_cv_file__dev_random=yes \
		./configure $(CFG) \
		--prefix=/ \
		--disable-failover --without-libbind --disable-tracing \
		CFLAGS="-Wall -Werror -fno-strict-aliasing -g -Os $(EXTRA_CFLAGS)" \
		LDFLAGS="$(EXTRA_LDFLAGS)"

clean:
	-make clean

install:
	@echo " ##   Installing dhcp client and server"
	make DESTDIR=$(STAGINGDIR) install

release:
	@echo " ##   Releasing dhcp client"
	$(INSTALL) -d $(ROOT_FS_DIR)/sbin
	$(INSTALL) -m 755 $(STAGINGDIR)/sbin/dhclient $(ROOT_FS_DIR)/sbin
	$(STRIP) $(ROOT_FS_DIR)/sbin/dhclient
	@echo " ##   Releasing dhcp server"
	$(INSTALL) -m 755 $(STAGINGDIR)/sbin/dhcpd $(ROOT_FS_DIR)/sbin
	$(STRIP) $(ROOT_FS_DIR)/sbin/dhcpd

doc:

.PHONY: all clean install release doc Makefile


