include $(STAGINGDIR)/components.config

SUBDIRS := linuxigd2

all:
	for dir in $(SUBDIRS) ; do $(MAKE) -C $$dir all || exit 1; done

install:
	for dir in $(SUBDIRS) ; do $(MAKE) -C $$dir install || exit 1; done

release:
	for dir in $(SUBDIRS) ; do $(MAKE) -C $$dir release || exit 1; done

clean:
	for dir in $(SUBDIRS) ; do $(MAKE) -C $$dir clean || exit 1; done

build_package:
	make -f Component.mk release ROOT_FS_DIR=$(COMP_PACKAGE_DIR)

release_package:
	cp -af $(COMP_PACKAGE_DIR)/* $(ROOT_FS_DIR)

test: createtest

createtest:
	@echo "Creating UPnP-IGD unit tests"
	@echo " Variable  COMPONENTNAME=$(COMPONENTNAME)"
	@echo " Variable  LOCALTESTDIR=$(LOCALTESTDIR)"
	$(MAKE) -C test
	$(INSTALL) -m 755 test/ft_testplan.sh $(LOCALTESTDIR)
	$(INSTALL) -m 755 test/miniupnpc-1.5.20110618/upnpc-static $(LOCALTESTDIR)
	$(INSTALL) -m 777 test/scripts/x86_start.sh $(STAGINGDIR)
	@echo "Done!"


.PHONY: all clean install release build_package release_package test createtest
