#ifndef _FW_WRAPPER_H_
#define _FW_WRAPPER_H_

#include "upnp/upnp.h"
#include "pmlist.h"
#include "pinholev6.h"
#include <pcb/pcb_client.h>

/**
	Add a new pinhole or update an existing one
*/

// All of these functions are only allowed to be called from the MAIN thread (PCB thread)
bool FWCancelPortMapExpirationTimer(struct portMap *portMap);
bool FWCancelPinHoleExpirationTimer(struct pinholev6 *pinhole);
bool FWSetPortMapping(struct portMap *portMap, bool newPortMap);
bool FWDelPortMapping(struct portMap *portMap);
bool FWOpenServicePorts();
bool FWCloseFirewall();

/* Remove all portmappings created by upnp-igd */
bool FWDelAllPortMappings();
/* Remove all pinholes created by upnp-igd */
bool FWDelAllPinholes();

bool FWAddPinHole(struct pinholev6 *pinHole, char *internal_client, char *remote_host, char *internal_port, char *remote_port, char *protocol);
bool FWDelPinHole(struct pinholev6 *pinHole);
bool FWUpdatePinHole(struct pinholev6 *pinHole);

#endif // _FW_WRAPPER_H_
