#ifndef _IPC_WRAPPER_H_
#define _IPC_WRAPPER_H_

#include "upnp/upnp.h"
#include <pcb/pcb_client.h>
#include "pmlist.h"
#include "pinholev6.h"
#include "nemo_wrapper.h"


/* we need this IPC wrapper to handle all PCB requests in the same thread (pcb_eventloop) */

bool IPC_Init();
bool IPC_Exit();

inline int IPC_GetReadSocket();

// functions to be used by the lib_upnp framework thread
bool IPC_request_SetPortMapping(struct portMap *portMap, bool newPortMap);
bool IPC_request_DelPortMapping(struct portMap *portMap);

bool IPC_request_AddPinHole(struct pinholev6 *pinHole, char *internal_client, char *remote_host, char *internal_port, char *remote_port, char *protocol);
bool IPC_request_DelPinHole(struct pinholev6 *pinHole);
bool IPC_request_UpdatePinHole(struct pinholev6 *pinHole);

bool IPC_request_GetLinkLayerMaxBitRates(nemo_link_layer_max_bit_rates *bitRates);

bool IPC_request_FirewallIsEnabled(bool *enabled);

// functions to be used by the pcb mainloop
bool IPC_handle_request(bool signalThread);

#endif // _IPC_WRAPPER_H_

