#!/bin/sh

# global variables
IP_ADDRESS=192.168.1.100

function check_test_result() {
	RC_STR="PASSED"
	if [ $1 -gt 0 ]
	then
		RC_STR="FAILED"
	fi

	echo -e "------------> result: $RC_STR($1)\n"
	return $1
}


function list_redirections() {
	echo -e "++++++++++++> List redirections $1"
	./upnpc-static -m $IP_ADDRESS -l
	check_test_result $?
}

function list_redirections_with_get_list_of_portmappings() {
	echo -e "++++++++++++> List redirections using GetListOfPortMappings (IGD v2) $1"
	./upnpc-static -m $IP_ADDRESS -L
	check_test_result $?
}

function get_connection_status() {
	echo -e "++++++++++++> Get connection status $1"
	./upnpc-static -m $IP_ADDRESS -s
	check_test_result $?
}

function get_firewall_status() {
	echo -e "++++++++++++> Get firewall status $1"
	./upnpc-static -m $IP_ADDRESS -S
	check_test_result $?
}

function get_presentation_url() {
	echo -e "++++++++++++> Get Presentation URL $1"
	./upnpc-static -m $IP_ADDRESS -P
	check_test_result $?
}

function add_portmappings() {
	echo -e "++++++++++++> Get Presentation URL $1"
	./upnpc-static -m $IP_ADDRESS -Y 30000 60
	check_test_result $?
}

# MAIN starts here

CNT=0
while [ true ]
do
	CNT=$((CNT+1))
	echo -e "\n====================================================="
	echo -e `date` " : RUN $CNT"
	echo -e "=====================================================\n"

	list_redirections
	list_redirections_with_get_list_of_portmappings
	get_connection_status
	get_presentation_url

	add_portmappings

	WAIT_CNT=1
	while [ $WAIT_CNT -lt 31 ]
	do
		WAIT_CNT=$((WAIT_CNT+1))
		list_redirections $WAIT_CNT
		sleep 2
	done
done