#!/bin/sh
# the next line restarts using tclsh \
    exec tclsh "$0" "$@"


# MAKE SURE NOBODY IS USING port 1900
# your default gw should point to the correct interface, otherwise the mcastadd wiil fail

#package require udp 1.0.9
package require udp

proc incoming {chan} {
  
  # Read UDP datagram.
  set data [read $chan]
  set peer [fconfigure $chan -peer]
  puts "SSDP message from [join $peer :] <>$data<>\n"
}

# HTTP/1.0 should fail
set mymessage "M-SEARCH * HTTP/1.1
HOST: 239.255.255.250:1900
MAN: \"ssdp:discover\"
MX:3
ST:ssdp:all\n"


# Open SSDP socket. This will stay open until a call to stop.
set s [udp_open 1900 reuse]

puts $s $mymessage

fconfigure $s -buffering none -blocking 0
fconfigure $s -mcastadd 239.255.255.250
fileevent $s readable [list incoming $s]


fconfigure $s -remote {239.255.255.250 1900}
puts "Sending MSEARCH"
puts $s $mymessage


vwait forever



