#!/bin/sh
# the next line restarts using tclsh \
    exec tclsh "$0" "$@"


# config settings
set myip "192.168.1.5"
set myclientport 10000
set myserverport 10001

set serverip "192.168.1.254"
set serverport 50000
set serverudn "e05412f5-0ac8-3a6c-a56f-ed7d6373ec80"

proc HandleEOF {sock} {
  # In this case, simply close our client socket.
  catch {close $sock}
}

proc ReadLine {sock} {
  if {[catch {gets $sock line} len] || [eof $sock]} {
    HandleEOF $sock
  } elseif {$len >= 0} {
    #ProcessLine $sock $line
    puts $line
  }
}

proc ClientConnect {sock host port} {
  puts "message from $host:$port"
  fconfigure $sock -buffering line -blocking 0
  fileevent $sock readable [list ReadLine $sock]
}


#### MAIN starts here
# parse commandline argument
if { $argc != 1 } {
  puts "usage: client.tcl <client_portNumber>\n"
  exit 1
}

set myclientport [lindex $argv 0]

# open server socket
set serversocket [socket -server ClientConnect 0]
set myserverport [lindex [chan configure $serversocket -sockname] 2]


# client stuff
set mymessage "SUBSCRIBE /upnp/control/WANIPConn1 HTTP/1.1
NT: upnp:event
TIMEOUT: Second-3000
HOST: $serverip:$serverport
CALLBACK: <http://$myip:$myserverport/$serverudn/urn:upnp-org:serviceId:WANIPConn1>
Content-Length: 0\n"

set sockChan [socket $serverip $serverport]

set socketList [chan configure $sockChan -sockname]
puts "number: [lindex $socketList 2]\n\n\n"
puts $sockChan $mymessage
close $sockChan


vwait forever


