#ifndef __PCB_SERIALIZE_DDW_H__
#define __PCB_SERIALIZE_DDW_H__

#include <pcb/utils.h>
#include <pcb/core.h>

#define DDW_VERSION_01 0x01

#define EOV 0x10001 // EOV = End-Of-Variants

bool ddw_serialize_reply_end(peer_info_t *peer, request_t *req);
bool ddw_serialize_functionReturnValue(peer_info_t *peer, request_t *req, const variant_t *retval);
bool ddw_serialize_functionReturnArguments(peer_info_t *peer, request_t *req, argument_value_list_t *args);
bool ddw_serialize_request(peer_info_t *peer, request_t *req);
bool ddw_serialize_objectBegin(peer_info_t *peer, request_t *req, object_t *object);
bool ddw_serialize_objectEnd(peer_info_t *peer, request_t *req);
bool ddw_serialize_parameter(peer_info_t *peer, request_t *req, parameter_t *parameter, bool hideValue);
bool ddw_serialize_notification(peer_info_t *peer, request_t *req,notification_t *notification);
bool ddw_serialize_error(peer_info_t *peer, request_t *req,uint32_t error, const char *description, const char *info);
void ddw_serialize_register();
void ddw_serialize_unregister();

bool ddw_deserialize_checkFormat_V01(peer_info_t *peer);
deserialize_return_t ddw_deserialize(peer_info_t *peer, pcb_t *connection);
void ddw_deserialize_cleanup(peer_info_t *peer);

static inline void ddw_byteswap(char *buf, int len) {
    static union {
        int i;
        char b[sizeof(int)];
    } test = { .i = 1 };
    if (test.b[0]) {
        int i;
        char c;
        for (i=0; i<len/2; i++) {
            c = buf[len-i-1];
            buf[len-i-1] = buf[i];
            buf[i] = c;
        }
    }
}


#endif

