#include <stdlib.h>

#include <debug/sahtrace.h>
#include <pcb/core/serialize.h>

#include "ddw.h"

static void ddw_unregister() {
    ddw_serialize_unregister();
}

void libpcb_serialize_ddw_register() {
    serialize_handlers_t *handlers = (serialize_handlers_t *)calloc(1,sizeof(serialize_handlers_t));
    if (!handlers)
        return;

    handlers->notificationBroadcastSupport = true;
    handlers->serialize_reply_end = ddw_serialize_reply_end;
    handlers->serialize_request = ddw_serialize_request;
    handlers->serialize_functionReturnValue = ddw_serialize_functionReturnValue;
    handlers->serialize_functionReturnArguments = ddw_serialize_functionReturnArguments;
    handlers->serialize_objectBegin = ddw_serialize_objectBegin;
    handlers->serialize_objectEnd = ddw_serialize_objectEnd;
    handlers->serialize_parameter = ddw_serialize_parameter;
    handlers->serialize_notification = ddw_serialize_notification;
    handlers->serialize_error = ddw_serialize_error;

    handlers->deserialize_checkFormat = ddw_deserialize_checkFormat_V01;
    handlers->deserialize = ddw_deserialize;
    handlers->deserialize_cleanup = ddw_deserialize_cleanup;

    handlers->unregister = ddw_unregister;

    ddw_serialize_register();

    serialization_addSerializer(handlers,SERIALIZE_FORMAT(serialize_format_ddw,0,0));

    SAH_TRACEZ_INFO("ddw", "loaded ddw serializer plugin");
}

