include $(STAGINGDIR)/components.config

PPPD_DIR = pppd-2.4.1
CHAT_DIR = chat
SCRIPTS_DIR = scripts
SUBDIRS = $(CHAT_DIR) $(PPPD_DIR)/plugins $(PPPD_DIR) pppstats pppdump

all: 
	for dir in $(SUBDIRS); do $(MAKE) -C $$dir all || exit 1; done

clean:
	rm -f `find . -name '*.[oas]' -print`
	rm -f `find . -name 'core' -print`
	rm -f `find . -name '*~' -print`
	for dir in $(SUBDIRS); do $(MAKE) -C $$dir clean || exit 1; done

install: all
	$(INSTALL) -d $(STAGINGDIR)/usr/sbin
	$(INSTALL) -d $(STAGINGDIR)/etc_ro_fs/ppp
	$(INSTALL) -m 755 $(PPPD_DIR)/pppd $(STAGINGDIR)/usr/sbin
	$(INSTALL) -m 755 pon $(STAGINGDIR)/usr/sbin
	$(INSTALL) -m 755 poff $(STAGINGDIR)/usr/sbin
	$(INSTALL) -m 755 $(CHAT_DIR)/chat $(STAGINGDIR)/usr/sbin
	$(INSTALL) -m 755 $(SCRIPTS_DIR)/ip-up $(STAGINGDIR)/etc_ro_fs/ppp
	$(INSTALL) -m 755 $(SCRIPTS_DIR)/ip-down $(STAGINGDIR)/etc_ro_fs/ppp
	
release: all
	$(INSTALL) -d $(ROOT_FS_DIR)/usr/sbin
	$(INSTALL) -d $(ROOT_FS_DIR)/etc_ro_fs/ppp
	$(INSTALL) -m 755 $(STAGINGDIR)/usr/sbin/pppd $(ROOT_FS_DIR)/usr/sbin
	$(INSTALL) -m 755 $(STAGINGDIR)/usr/sbin/pon $(ROOT_FS_DIR)/usr/sbin
	$(INSTALL) -m 755 $(STAGINGDIR)/usr/sbin/poff $(ROOT_FS_DIR)/usr/sbin
	$(INSTALL) -m 755 $(STAGINGDIR)/usr/sbin/chat $(ROOT_FS_DIR)/usr/sbin
	$(INSTALL) -m 755 $(STAGINGDIR)/etc_ro_fs/ppp/ip-up $(ROOT_FS_DIR)/etc_ro_fs/ppp
	$(INSTALL) -m 755 $(STAGINGDIR)/etc_ro_fs/ppp/ip-down $(ROOT_FS_DIR)/etc_ro_fs/ppp
	$(STRIP) $(ROOT_FS_DIR)/usr/sbin/pppd
	$(STRIP) $(ROOT_FS_DIR)/usr/sbin/chat

.PHONY: clean all install release

