VERS         = 1.0.7
CFLAGS      += -l usb -Wall -DUSE_SYSLOG -I$(STAGINGDIR)/include -L$(STAGINGDIR)/lib

export VERSION=$(VERS)

.PHONY:     clean install release

all:        usb_modeswitch

usb_modeswitch: usb_modeswitch.c
	$(CC) $(CFLAGS) -o usb_modeswitch usb_modeswitch.c

clean:
	rm -f usb_modeswitch

install: all
	$(INSTALL) -d $(STAGINGDIR)/usr/sbin
	$(INSTALL) -d $(STAGINGDIR)/etc/
	$(INSTALL) -d $(STAGINGDIR)/etc/usb_modeswitch.d/
	$(INSTALL) -d $(STAGINGDIR)/etc/init.d
	$(INSTALL) -d $(STAGINGDIR)/etc/rc1.d
	$(INSTALL) -d $(STAGINGDIR)/etc/mdev.d/
	$(INSTALL) -m 754 usb_modeswitch $(STAGINGDIR)/usr/sbin
	$(INSTALL) -m 754 ./usb_modeswitch.sh $(STAGINGDIR)/usr/sbin
	$(INSTALL) -m 644 ./usb_modeswitch.d/* $(STAGINGDIR)/etc/usb_modeswitch.d/
	$(INSTALL) -m 644 mdev.conf $(STAGINGDIR)/etc/mdev.d/50-usb-modeswitch.conf
	$(INSTALL) -m 755 usb_modeswitch_boot $(STAGINGDIR)/etc/init.d/
	ln -sf ../init.d/usb_modeswitch_boot $(STAGINGDIR)/etc/rc1.d/S89usb_modeswitch_boot


release:
	$(INSTALL) -d $(ROOT_FS_DIR)/usr/sbin
	$(INSTALL) -d $(ROOT_FS_DIR)/etc_ro_fs/
	$(INSTALL) -d $(ROOT_FS_DIR)/etc_ro_fs/usb_modeswitch.d/
	$(INSTALL) -d $(ROOT_FS_DIR)/etc_ro_fs/init.d
	$(INSTALL) -d $(ROOT_FS_DIR)/etc_ro_fs/rc1.d
	$(INSTALL) -d $(ROOT_FS_DIR)/etc_ro_fs/mdev.d
	$(INSTALL) -m 754 $(STAGINGDIR)/usr/sbin/usb_modeswitch $(ROOT_FS_DIR)/usr/sbin/
	$(STRIP) $(ROOT_FS_DIR)/usr/sbin/usb_modeswitch
	$(INSTALL) -m 754 $(STAGINGDIR)/usr/sbin/usb_modeswitch.sh $(ROOT_FS_DIR)/usr/sbin/
	$(INSTALL) -m 644 $(STAGINGDIR)/etc/usb_modeswitch.d/* $(ROOT_FS_DIR)/etc_ro_fs/usb_modeswitch.d/
	$(INSTALL) -m 644 $(STAGINGDIR)/etc/mdev.d/50-usb-modeswitch.conf $(ROOT_FS_DIR)/etc_ro_fs/mdev.d/50-usb-modeswitch.conf
	$(INSTALL) -m 755 $(STAGINGDIR)/etc/init.d/usb_modeswitch_boot $(ROOT_FS_DIR)/etc_ro_fs/init.d/usb_modeswitch_boot
	ln -sf ../init.d/usb_modeswitch_boot $(ROOT_FS_DIR)/etc_ro_fs/rc1.d/S89usb_modeswitch_boot

